package com.dragoninfo.dcuc.coder.facace;


import com.dragonsoft.duceap.base.entity.metadata.CodeDicDTO;
import com.dragonsoft.duceap.base.entity.search.SearchDTO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * @author liws
 * @date 2020/3/4
 */
@FeignClient(value = "dcuc-coder", path = "/dcuc/coder/codeInfoFacade")
public interface ICodeInfoFacade {
    /**
     * 表码表列表
     *
     * @param searchDTO 搜索条件
     * @return 分页
     */
    @PostMapping(value = "page")
    Page<CodeDicDTO> page(@RequestBody SearchDTO searchDTO);

    /**
     * 删除
     *
     * @param id ID
     */
    @RequestMapping(value = "delete")
    void delete(@RequestParam("id") String id);

    /**
     * 表码 data数据列表
     *
     * @return 列表
     */
    @PostMapping(value = "pageCodeDicData")
    List<Map<String, Object>> pageCodeDicData(@RequestBody SearchDTO searchDTO);
}
