package com.dragoninfo.dcuc.coder.facace;


import com.dragoninfo.dcuc.duceap.metedata.dto.MdDatasourceDTO;
import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
import com.dragonsoft.duceap.base.entity.search.SearchDTO;
import com.dragonsoft.duceap.core.search.Searchable;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * @author liws
 * @date 2020/3/4
 */
@FeignClient(value = "dcuc-coder", path = "/dcuc/coder/mdDataSourceFacade")
public interface IMdDataSourceFacade {

    /**
     * 分页信息
     *
     * @param searchDTO 搜索条件
     * @return 分页
     */
    @PostMapping(value = "paging")
    Page<MdDatasourceDTO> paging(@RequestBody SearchDTO searchDTO);

    /**
     * 删除
     *
     * @param id ID
     */
    @RequestMapping(value = "delete")
    void delete(@RequestParam("id") String id);

    @RequestMapping(value = "findList")
    List<MdDatasourceDTO> findList(Searchable searchable);

    @RequestMapping(value = "testConnetion")
    ResponseStatus testConnetion(MdDatasourceDTO data);

    @RequestMapping(value = "detail")
    MdDatasourceDTO detail(@RequestParam("datasourceId") String datasourceId);

    @RequestMapping(value = "getDataSources")
    List<Map<String, Object>> getDataSources();
}
