package com.dragoninfo.dcuc.coder.bpo;

import com.dragonsoft.duceap.base.entity.metadata.CodeDicDTO;
import com.dragonsoft.duceap.commons.util.string.StringUtils;
import com.dragonsoft.duceap.core.persistent.dao.jdbc.IBaseDAOJdbc;
import com.dragonsoft.duceap.core.persistent.factory.PersistentFactory;
import com.dragonsoft.duceap.core.search.Searchable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public class CodeDicBPO {
    public Page<CodeDicDTO> paging(Searchable searchable) {
        String sql = "SELECT * FROM T_MD_SYS_CODE_DIC";
        Page<CodeDicDTO> mdDatasource = PersistentFactory.getJdbcDao().paging(sql, searchable, CodeDicDTO.class);
        return mdDatasource;
    }

    public void delete(String id) {
        String sql = "delete from T_MD_SYS_CODE_DIC where CODE_ID=?";
        PersistentFactory.getJdbcDao().update(sql, new Object[]{id});
    }

    public List<CodeDicDTO> findList(Searchable searchable) {
        String sql = "SELECT * FROM T_MD_SYS_CODE_DIC T WHERE T.LOAD_TYPE = '1'";
        List<CodeDicDTO> list = PersistentFactory.getJdbcDao().queryforlist(sql, CodeDicDTO.class, searchable);
        return list;
    }

    public List<Map<String, Object>> pageCodeDicData(Searchable searchable, CodeDicDTO codeDic) {
        searchable.addSort(Sort.Direction.ASC, codeDic.getCodeField());
        String sql = "SELECT * FROM " + codeDic.getEntityName() + " T ";
        IBaseDAOJdbc iBaseDAOJdbc = StringUtils.isEmpty(codeDic.getDatasourceId()) ? PersistentFactory.getJdbcDao() : PersistentFactory.getJdbcDao(codeDic.getDatasourceId());
        List<Map<String, Object>> list = iBaseDAOJdbc.queryforlist(sql, searchable);
        return list;
    }


}
