package com.dragoninfo.dcuc.coder.bpo;

import com.dragonsoft.duceap.core.persistent.factory.PersistentFactory;
import com.dragonsoft.duceap.core.search.Searchable;
import com.dragonsoft.duceap.metadata.model.MdDatasource;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public class DataSourceBPO {
    public Page<MdDatasource> paging(Searchable searchable) {
        String sql = "select * from t_md_datasource";
        Page<MdDatasource> mdDatasource = PersistentFactory.getJdbcDao().paging(sql, searchable, MdDatasource.class);
        return mdDatasource;
    }

    public void delete(String id) {
        String sql = "delete from t_md_datasource where datasource_id=?";
        PersistentFactory.getJdbcDao().update(sql, new Object[]{id});
    }

    public List<MdDatasource> findList(Searchable searchable) {
        String sql = "select * from t_md_datasource";
        List<MdDatasource> list = PersistentFactory.getJdbcDao().queryforlist(sql, MdDatasource.class, searchable);
        return list;
    }

    public MdDatasource detail(String datasourceId) {
        String sql = "select * from t_md_datasource where datasource_id = ?";
        return PersistentFactory.getJdbcDao().queryUniqueResult(sql, MdDatasource.class, new String[]{datasourceId});

    }

    public List<Map<String, Object>> getDataSources() {
        String sql = "select datasource_id as code,name as value from t_md_datasource ";
        return PersistentFactory.getJdbcDao().queryForList(sql);
    }
}
