package com.dragoninfo.dcuc.coder.facade;

import com.dragoninfo.dcuc.coder.facace.ICodeInfoFacade;
import com.dragoninfo.dcuc.coder.service.ICodeDicService;
import com.dragoninfo.dcuc.duceap.facade.IDuceapCodeFacade;
import com.dragonsoft.duceap.base.entity.metadata.CodeDicDTO;
import com.dragonsoft.duceap.base.entity.search.SearchDTO;
import com.dragonsoft.duceap.core.search.Searchable;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * @author liws
 * @date 2020/3/4
 */
@RestController
@RequestMapping(value = "/dcuc/coder/codeInfoFacade")
public class CodeInfoFacade implements ICodeInfoFacade {

    @Autowired
    private ICodeDicService codeDicService;

    @Autowired
    private IDuceapCodeFacade duceapCodeFacade;

    @Override
    public Page<CodeDicDTO> page(SearchDTO searchDTO) {
        Searchable searchable = Searchable.toSearchable(searchDTO);
        return codeDicService.paging(searchable);
    }

    @Override
    public void delete(String id) {
        codeDicService.delete(id);
    }

    @Override
    public List<Map<String, Object>> pageCodeDicData(SearchDTO searchDTO) {
        Searchable searchable = Searchable.toSearchable(searchDTO);
        String code_id = (String) searchable.getSearchFilterByKey("codeId_eq").getValue();
        searchable.removeSearchFilter("codeId_eq");
        CodeDicDTO codeDicDTO = this.get(code_id);
        return codeDicService.pageCodeDicData(searchable, codeDicDTO);
    }


    private CodeDicDTO get(String codeDicId) {
        return duceapCodeFacade.get(codeDicId);
    }
}
