package com.dragoninfo.dcuc.coder.facade;

import com.dragoninfo.dcuc.coder.facace.IMdDataSourceFacade;
import com.dragoninfo.dcuc.coder.service.IDataSourceService;
import com.dragoninfo.dcuc.duceap.metedata.dto.MdDatasourceDTO;
import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
import com.dragonsoft.duceap.base.entity.search.SearchDTO;
import com.dragonsoft.duceap.core.entity.page.PageImpl;
import com.dragonsoft.duceap.core.search.Searchable;
import com.dragonsoft.duceap.metadata.model.MdDatasource;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author liws
 * @date 2020/3/4
 */
@RestController
@RequestMapping(value = "/dcuc/coder/mdDataSourceFacade")
public class MdDataSourceFacade implements IMdDataSourceFacade {

    @Autowired
    private IDataSourceService iDataSourceService;

    @Override
    public Page<MdDatasourceDTO> paging(SearchDTO searchDTO) {
        Searchable searchable = Searchable.toSearchable(searchDTO);
        Page<MdDatasource> paging = iDataSourceService.paging(searchable);
        List<MdDatasource> content = paging.getContent();
        List<MdDatasourceDTO> dtoList = new ArrayList<>();
        for (MdDatasource datasource : content) {
            MdDatasourceDTO mdDatasourceDTO = new MdDatasourceDTO();
            BeanUtils.copyProperties(datasource, mdDatasourceDTO);
            dtoList.add(mdDatasourceDTO);
        }
        return new PageImpl<>(dtoList, searchable.getPage(), paging.getTotalElements());
    }

    @Override
    public void delete(String id) {
        iDataSourceService.delete(id);
    }

    @Override
    public List<MdDatasourceDTO> findList(Searchable searchable) {
        List<MdDatasource> list = iDataSourceService.findList(searchable);
        List<MdDatasourceDTO> dtoList = new ArrayList<>();
        for (MdDatasource datasource : list) {
            MdDatasourceDTO mdDatasourceDTO = new MdDatasourceDTO();
            BeanUtils.copyProperties(datasource, mdDatasourceDTO);
            dtoList.add(mdDatasourceDTO);
        }
        return dtoList;
    }

    @Override
    public ResponseStatus testConnetion(MdDatasourceDTO data) {
        MdDatasource datasource = new MdDatasource();
        BeanUtils.copyProperties(data, datasource);
        return iDataSourceService.testConnetion(datasource);
    }

    @Override
    public MdDatasourceDTO detail(String datasourceId) {
        MdDatasource mdDatasource = iDataSourceService.detail(datasourceId);
        MdDatasourceDTO mdDatasourceDTO = new MdDatasourceDTO();
        BeanUtils.copyProperties(mdDatasource, mdDatasourceDTO);
        return mdDatasourceDTO;
    }

    @Override
    public List<Map<String, Object>> getDataSources() {
        return iDataSourceService.getDataSources();
    }
}
