package com.dragoninfo.dcuc.coder.service.impl;

import com.dragoninfo.dcuc.coder.bpo.DataSourceBPO;
import com.dragoninfo.dcuc.coder.service.IDataSourceService;
import com.dragonsoft.duceap.base.entity.http.ResponseStatus;
import com.dragonsoft.duceap.core.search.Searchable;
import com.dragonsoft.duceap.metadata.model.MdDatasource;
import com.dragonsoft.duceap.metadata.util.MdDataSourceUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.sql.DataSource;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class DataSourServiceImpl implements IDataSourceService {
    @Autowired
    private DataSourceBPO dataSourceBPO;

    @Override
    public Page<MdDatasource> paging(Searchable searchable) {
        Page<MdDatasource> page = dataSourceBPO.paging(searchable);
        return page;
    }

    @Override
    public MdDatasource detail(String datasourceId) {
        return dataSourceBPO.detail(datasourceId);
    }

    @Override
    public List<Map<String, Object>> getDataSources() {
        return dataSourceBPO.getDataSources();
    }

    @Override
    public void delete(String id) {
        dataSourceBPO.delete(id);
    }

    @Override
    public List<MdDatasource> findList(Searchable searchable) {
        return dataSourceBPO.findList(searchable);
    }

    @Override
    public ResponseStatus testConnetion(MdDatasource data) {
        try {
            DataSource dataSource = MdDataSourceUtils.buildDataSource(data);
            if (dataSource == null)
                throw new Exception();
        } catch (Exception e) {
            return ResponseStatus.fail("连接失败");
        }
        return ResponseStatus.success("连接成功");
    }
}
