-- Create table
-- 警衔表码表
CREATE TABLE `dm_police_rank` (
  `CODE` varchar(4) NOT NULL,
  `NAME` varchar(40) DEFAULT NULL,
  `SORT_NO` decimal(5,0) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- 职位表
-- Create table
CREATE TABLE `dm_cert_duty_level` (
  `CODE` varchar(10) DEFAULT NULL COMMENT '代码',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `SORT` decimal(5,0) DEFAULT NULL COMMENT '排序'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='职级代码';


-- 行政化区编码
CREATE TABLE `t_md_area_code` (
  `CODE` varchar(6) DEFAULT NULL COMMENT '编号',
  `NAME` varchar(60) DEFAULT NULL COMMENT '名称',
  `SORT_NO` decimal(5,0) DEFAULT NULL COMMENT '排序'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='行政区划信息表';


-- 机构标准代码表
CREATE TABLE `t_md_orgbiz_code` (
  `CODE` varchar(6) NOT NULL COMMENT '代码',
  `NAME` varchar(40) NOT NULL COMMENT '名称',
  `IS_ACTIVE` char(1) NOT NULL COMMENT '有效否，1有效，0无效'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='机构标准代码表，作为表码，用于产生机构代码';


-- 机构类别表码
CREATE TABLE `t_md_orgtype` (
  `CODE` varchar(2) NOT NULL,
  `NAME` varchar(30) DEFAULT NULL,
  `SORT_NO` decimal(5,0) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='机构类别表码';


-- 单位层级表码
CREATE TABLE `t_md_org_level` (
  `CODE` varchar(2) NOT NULL,
  `NAME` varchar(30) DEFAULT NULL,
  `SORT_NO` decimal(5,0) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单位层级表码';


-- Create table
-- 警员人员类型表码
CREATE TABLE `dm_man_type` (
  `CODE` varchar(32) DEFAULT NULL,
  `VALUE` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- Create table
CREATE TABLE `dm_nation_code` (
  `ID` varchar(32) DEFAULT NULL,
  `CODE` varchar(32) DEFAULT NULL,
  `NAME` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='民族表';


-- Create table 警种，表码
CREATE TABLE `t_md_police_type` (
  `CODE` varchar(6) DEFAULT NULL COMMENT '编号',
  `VALUE` varchar(50) DEFAULT NULL COMMENT '名称'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='警种，表码';


-- 用户类型表码
CREATE TABLE `dm_user_type` (
  `CODE` varchar(32) DEFAULT NULL,
  `VALUE` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- Create table
CREATE TABLE `dm_police_business` (
  `CODE` varchar(6) DEFAULT NULL COMMENT '编号',
  `VALUE` varchar(50) DEFAULT NULL COMMENT '名称',
  `POLICE_TYPE_ID` varchar(6) DEFAULT NULL COMMENT '警种id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='业务域表';


CREATE TABLE `dm_apply_category` (
  `CODE` varchar(32) DEFAULT NULL,
  `VALUE` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='应用类别';


CREATE TABLE `dm_apply_status` (
  `CODE` varchar(32) DEFAULT NULL,
  `VALUE` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='应用状态';


CREATE TABLE `dm_tenant_object` (
  `CODE` varchar(32) DEFAULT NULL,
  `VALUE` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='租户对象表';


CREATE TABLE `dm_auxiliary_type` (
  `CODE` varchar(32) DEFAULT NULL,
  `VALUE` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='辅警人员类型表';


-- Create table
CREATE TABLE `t_md_unit_class` (
  `CODE` varchar(32) DEFAULT NULL,
  `VALUE` varchar(50) DEFAULT NULL,
  `REMARK` varchar(50) DEFAULT NULL,
  `PCODE` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


-- Create table
CREATE TABLE `t_md_org_rank` (
  `CODE` varchar(2) NOT NULL,
  `NAME` varchar(30) DEFAULT NULL,
  `SORT_NO` decimal(5,0) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='单位级别表码';


CREATE TABLE `dm_user_status` (
  `CODE` varchar(32) DEFAULT NULL,
  `NAME` varchar(32) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE `dm_job_type` (
  `code` varchar(5) DEFAULT NULL,
  `value` varchar(10) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_POLICE_RANK', '', '警衔表码表', 'DM_POLICE_RANK', 'CODE', 'NAME', null, null, null, null, null, '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_CERT_DUTY_LEVEL', '', '职位表', 'DM_CERT_DUTY_LEVEL', 'CODE', 'NAME', null, null, null, null, null, '1');
insert into t_md_sys_code_dic (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('T_MD_AREA_CODE', '', '行政区划', 'T_MD_AREA_CODE', 'CODE', 'NAME', '', '', '', '2:2:2', '', '1');
insert into t_md_sys_code_dic (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('T_MD_ORGBIZ_CODE', '', '标准代码', 'T_MD_ORGBIZ_CODE', 'CODE', 'NAME', '', '', '', '', '', '1');
insert into t_md_sys_code_dic (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('T_MD_ORGTYPE', '', '机构类别', 'T_MD_ORGTYPE', 'CODE', 'NAME', '', '', '', '', '', '1');
insert into t_md_sys_code_dic (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('T_MD_ORG_LEVEL', '', '单位层级', 'T_MD_ORG_LEVEL', 'CODE', 'NAME', '', '', 'SORT_NO', '', '', '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_MAN_TYPE', '', '警员人员类型', 'DM_MAN_TYPE', 'CODE', 'VALUE', null, null, null, null, null, '2');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_NATION_CODE', '', '民族表', 'DM_NATION_CODE', 'CODE', 'NAME', null, null, null, null, null, '1');
insert into t_md_sys_code_dic (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('T_MD_POLICE_TYPE', '', '警种', 'T_MD_POLICE_TYPE', 'CODE', 'VALUE', '', '', '', '', '', '2');
insert into t_md_sys_code_dic (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_ROLE_LEVEL', '', '角色层级', 'DM_SYS_CODE', 'CODE', 'VALUE', null, null, null, null, 'CODE_ID=''rolelevel''', '1');
insert into t_md_sys_code_dic (code_id, datasource_id, name, entity_name, code_field, name_field, py_field, wb_field, order_field, segment_rule, view_sql, load_type)
values ('DM_DATASOURCE', '', '数据源', 'T_MD_DATASOURCE', 'DATASOURCE_ID', 'NAME', null, null, null, null, null, '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_USER_TYPE', '', '人员类型', 'DM_USER_TYPE', 'CODE', 'VALUE', null, null, null, null, null, '2');
insert into t_md_sys_code_dic (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_POLICE_BUSINESS', '', '业务域', 'DM_POLICE_BUSINESS', 'CODE', 'VALUE', '', '', '', '', '', '2');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_APPLY_CATEGORY', '', '应用类别', 'DM_APPLY_CATEGORY', 'CODE', 'VALUE', null, null, null, '2:2:2', null, '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_APPLY_STATUS', '', '应用状态', 'DM_APPLY_STATUS', 'CODE', 'VALUE', null, null, null, '2:2:2', null, '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_TENANT_OBJECT', '', '租户对象', 'DM_TENANT_OBJECT', 'CODE', 'VALUE', null, null, null, '2:2:2', null, '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_AUXILIARY_TYPE', '', '辅警人员类型', 'DM_AUXILIARY_TYPE', 'CODE', 'VALUE', null, null, null, '2:2:2', null, '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('T_MD_UNIT_CLASS', '', '单位类别', 'T_MD_UNIT_CLASS', 'CODE', 'VALUE', null, null, null, null, null, '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('T_MD_ORG_RANK', '', '单位级别', 'T_MD_ORG_RANK', 'CODE', 'NAME', '', '', '', '', '', '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_USER_STATUS', '', '人员状态', 'DM_USER_STATUS', 'CODE', 'NAME', '', '', '', '', '', '1');
insert into T_MD_SYS_CODE_DIC (CODE_ID, DATASOURCE_ID, NAME, ENTITY_NAME, CODE_FIELD, NAME_FIELD, PY_FIELD, WB_FIELD, ORDER_FIELD, SEGMENT_RULE, VIEW_SQL, LOAD_TYPE)
values ('DM_JOB_TYPE', '', '在职类型', 'DM_JOB_TYPE', 'CODE', 'VALUE', '', '', '', '', '', '2');


insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2011', '总警监', 1);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2012', '副总警监', 2);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2101', '一级警监', 3);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2102', '二级警监', 4);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2103', '三级警监', 5);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2201', '一级警督', 6);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2202', '二级警督', 7);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2203', '三级警督', 8);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2301', '一级警司', 9);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2302', '二级警司', 10);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2303', '三级警司', 11);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2401', '一级警员', 12);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2402', '二级警员', 13);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2601', '一级警监(技术)', 14);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2602', '二级警监(技术)', 15);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2603', '三级警监(技术)', 16);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2701', '一级警督(技术)', 17);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2702', '二级警督(技术)', 18);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2703', '三级警督(技术)', 19);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2801', '一级警司(技术)', 20);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2802', '二级警司(技术)', 21);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2803', '三级警司(技术)', 22);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2901', '一级警员(技术)', 23);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2902', '二级警员(技术)', 24);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2997', '见习', 25);
insert into dm_police_rank (CODE, NAME, SORT_NO)
values ('2998', '学员', 26);

insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0130', '正部职', 1);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0131', '正部级', 2);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0132', '副部职', 3);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0141', '副部级', 4);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0142', '正厅职', 5);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0143', '正厅级', 6);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0150', '副厅职', 7);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0153', '副厅级', 8);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0154', '正处职', 9);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0155', '正处级', 10);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0156', '副处职', 11);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0160', '副处级', 12);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0161', '正科职', 13);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0162', '正科级', 14);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0163', '副科职', 15);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0164', '副科级', 16);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0165', '正股职', 17);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0166', '正股级', 18);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0170', '副股职', 19);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0171', '副股级', 20);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0172', '科员', 21);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0173', '办事员', 22);
insert into dm_cert_duty_level (CODE, NAME, SORT)
values ('0175', '未定职公务员', 23);

insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230300', '黑龙江省鸡西市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230301', '黑龙江省鸡西市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230302', '黑龙江省鸡西市鸡冠区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230303', '黑龙江省鸡西市恒山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230304', '黑龙江省鸡西市滴道区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230305', '黑龙江省鸡西市梨树区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230306', '黑龙江省鸡西市城子河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230307', '黑龙江省鸡西市麻山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230321', '黑龙江省鸡东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230381', '黑龙江省虎林市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230382', '黑龙江省密山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230400', '黑龙江省鹤岗市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230401', '黑龙江省鹤岗市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230402', '黑龙江省鹤岗市向阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230403', '黑龙江省鹤岗市工农区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230404', '黑龙江省鹤岗市南山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230405', '黑龙江省鹤岗市兴安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230406', '黑龙江省鹤岗市东山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230407', '黑龙江省鹤岗市兴山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230421', '黑龙江省萝北县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230422', '黑龙江省绥滨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230500', '黑龙江省双鸭山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230501', '黑龙江省双鸭山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230502', '黑龙江省双鸭山市尖山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230503', '黑龙江省双鸭山市岭东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230505', '黑龙江省双鸭山市四方台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230506', '黑龙江省双鸭山市宝山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230521', '黑龙江省集贤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230522', '黑龙江省友谊县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230523', '黑龙江省宝清县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230524', '黑龙江省饶河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230600', '黑龙江省大庆市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230601', '黑龙江省大庆市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230602', '黑龙江省大庆市萨尔图区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230603', '黑龙江省大庆市龙凤区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110000', '北京市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110100', '北京市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110101', '北京市东城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110102', '北京市西城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110103', '北京市崇文区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110104', '北京市宣武区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110105', '北京市朝阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110106', '北京市丰台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110107', '北京市石景山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110108', '北京市海淀区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110109', '北京市门头沟区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110111', '北京市房山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110112', '北京市通州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110113', '北京市顺义区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110114', '北京市昌平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110115', '北京市大兴区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110116', '北京市怀柔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110117', '北京市平谷区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110200', '北京市县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110228', '北京市密云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('110229', '北京市延庆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120000', '天津市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120100', '天津市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120101', '天津市和平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120102', '天津市河东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120103', '天津市河西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120104', '天津市南开区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120105', '天津市河北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120106', '天津市红桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120107', '天津市塘沽区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120108', '天津市汉沽区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120109', '天津市大港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120110', '天津市东丽区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120111', '天津市西青区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120112', '天津市津南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120113', '天津市北辰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120114', '天津市武清区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120115', '天津市宝坻区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120200', '天津市县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120221', '天津市宁河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120223', '天津市静海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('120225', '天津市蓟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130000', '河北省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130100', '河北省石家庄市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130101', '河北省石家庄市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130102', '河北省石家庄市长安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130103', '河北省石家庄市桥东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130104', '河北省石家庄市桥西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130105', '河北省石家庄市新华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130107', '河北省石家庄市井陉矿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130108', '河北省石家庄市裕华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130121', '河北省井陉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130123', '河北省正定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130124', '河北省栾城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130125', '河北省行唐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130126', '河北省灵寿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130127', '河北省高邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130128', '河北省深泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130129', '河北省赞皇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130130', '河北省无极县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130131', '河北省平山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130132', '河北省元氏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130133', '河北省赵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130181', '河北省辛集市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130182', '河北省藁城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130183', '河北省晋州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130184', '河北省新乐市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130185', '河北省鹿泉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130200', '河北省唐山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130201', '河北省唐山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130202', '河北省唐山市路南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130203', '河北省唐山市路北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130204', '河北省唐山市古冶区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130205', '河北省唐山市开平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130207', '河北省唐山市丰南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130208', '河北省唐山市丰润区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130223', '河北省滦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130224', '河北省滦南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130225', '河北省乐亭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130227', '河北省迁西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130229', '河北省玉田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130230', '河北省唐海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130281', '河北省遵化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130283', '河北省迁安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130300', '河北省秦皇岛市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130301', '河北省秦皇岛市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130302', '河北省秦皇岛市海港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130303', '河北省秦皇岛市山海关区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130304', '河北省秦皇岛市北戴河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130321', '河北省青龙满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130322', '河北省昌黎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130323', '河北省抚宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130324', '河北省卢龙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130400', '河北省邯郸市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130401', '河北省邯郸市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130402', '河北省邯郸市邯山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130403', '河北省邯郸市丛台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130404', '河北省邯郸市复兴区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130406', '河北省邯郸市峰峰矿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130421', '河北省邯郸县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130423', '河北省临漳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130424', '河北省成安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130425', '河北省大名县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130426', '河北省涉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130427', '河北省磁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130428', '河北省肥乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130429', '河北省永年县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130430', '河北省邱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130431', '河北省鸡泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130432', '河北省广平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130433', '河北省馆陶县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130434', '河北省魏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130435', '河北省曲周县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130481', '河北省武安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130500', '河北省邢台市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130501', '河北省邢台市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130502', '河北省邢台市桥东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130503', '河北省邢台市桥西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130521', '河北省邢台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130522', '河北省临城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130523', '河北省内丘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130524', '河北省柏乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130525', '河北省隆尧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130526', '河北省任县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130527', '河北省南和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130528', '河北省宁晋县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130529', '河北省巨鹿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130530', '河北省新河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130531', '河北省广宗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130532', '河北省平乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130533', '河北省威县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130534', '河北省清河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130535', '河北省临西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130581', '河北省南宫市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130582', '河北省沙河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130600', '河北省保定市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130601', '河北省保定市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130602', '河北省保定市新市区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130603', '河北省保定市北市区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130604', '河北省保定市南市区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130621', '河北省满城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130622', '河北省清苑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130623', '河北省涞水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130624', '河北省阜平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130625', '河北省徐水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130626', '河北省定兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130627', '河北省唐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130628', '河北省高阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130629', '河北省容城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130630', '河北省涞源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130631', '河北省望都县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130632', '河北省安新县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130633', '河北省易县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130634', '河北省曲阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130635', '河北省蠡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130636', '河北省顺平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130637', '河北省博野县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130638', '河北省雄县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130681', '河北省涿州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130682', '河北省定州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350128', '福建省平潭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350181', '福建省福清市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350182', '福建省长乐市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350200', '福建省厦门市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350201', '福建省厦门市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350203', '福建省厦门市思明区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350205', '福建省厦门市海沧区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350206', '福建省厦门市湖里区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350211', '福建省厦门市集美区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350212', '福建省厦门市同安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350213', '福建省厦门市翔安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350300', '福建省莆田市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350301', '福建省莆田市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350302', '福建省莆田市城厢区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140411', '山西省长治市郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140421', '山西省长治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140423', '山西省襄垣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140424', '山西省屯留县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140425', '山西省平顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140426', '山西省黎城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140427', '山西省壶关县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140428', '山西省长子县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140429', '山西省武乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140430', '山西省沁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140431', '山西省沁源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140481', '山西省潞城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140500', '山西省晋城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140501', '山西省晋城市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140502', '山西省晋城市城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140521', '山西省沁水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140522', '山西省阳城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140524', '山西省陵川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140525', '山西省泽州县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140581', '山西省高平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140600', '山西省朔州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140601', '山西省朔州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140602', '山西省朔州市朔城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140603', '山西省朔州市平鲁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140621', '山西省山阴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140622', '山西省应县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140623', '山西省右玉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140624', '山西省怀仁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140700', '山西省晋中市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140701', '山西省晋中市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140702', '山西省晋中市榆次区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140721', '山西省榆社县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140722', '山西省左权县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140723', '山西省和顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140724', '山西省昔阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140725', '山西省寿阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140726', '山西省太谷县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140727', '山西省祁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140728', '山西省平遥县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140729', '山西省灵石县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140781', '山西省介休市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140800', '山西省运城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140801', '山西省运城市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140802', '山西省运城市盐湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140821', '山西省临猗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140822', '山西省万荣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140823', '山西省闻喜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140824', '山西省稷山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140825', '山西省新绛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140826', '山西省绛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140827', '山西省垣曲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140828', '山西省夏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140829', '山西省平陆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140830', '山西省芮城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140881', '山西省永济市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140882', '山西省河津市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140900', '山西省忻州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140901', '山西省忻州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140902', '山西省忻州市忻府区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140921', '山西省定襄县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140922', '山西省五台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140923', '山西省代县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140924', '山西省繁峙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140925', '山西省宁武县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140926', '山西省静乐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140927', '山西省神池县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140928', '山西省五寨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140929', '山西省岢岚县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140930', '山西省河曲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140931', '山西省保德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140932', '山西省偏关县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140981', '山西省原平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141000', '山西省临汾市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141001', '山西省临汾市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141002', '山西省临汾市尧都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141021', '山西省曲沃县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141022', '山西省翼城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141023', '山西省襄汾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141024', '山西省洪洞县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141025', '山西省古县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141026', '山西省安泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141027', '山西省浮山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141028', '山西省吉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141029', '山西省乡宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141030', '山西省大宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141031', '山西省隰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141032', '山西省永和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141033', '山西省蒲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141034', '山西省汾西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141081', '山西省侯马市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141082', '山西省霍州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141100', '山西省吕梁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141101', '山西省吕梁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141102', '山西省吕梁市离石区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141121', '山西省文水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141122', '山西省交城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141123', '山西省兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141124', '山西省临县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141125', '山西省柳林县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141126', '山西省石楼县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141127', '山西省岚县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141128', '山西省方山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141129', '山西省中阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141130', '山西省交口县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141181', '山西省孝义市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('141182', '山西省汾阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150000', '内蒙古自治区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150100', '内蒙古呼和浩特市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150101', '内蒙古呼和浩特市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150102', '内蒙古呼和浩特市新城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150103', '内蒙古呼和浩特市回民区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150104', '内蒙古呼和浩特市玉泉区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150105', '内蒙古呼和浩特市赛罕区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150121', '内蒙古土默特左旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150122', '内蒙古托克托县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150123', '内蒙古和林格尔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150124', '内蒙古清水河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150125', '内蒙古武川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150200', '内蒙古包头市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150201', '内蒙古包头市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150202', '内蒙古包头市东河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150203', '内蒙古包头市昆都仑区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150204', '内蒙古包头市青山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150205', '内蒙古包头市石拐区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150206', '内蒙古包头市白云矿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150207', '内蒙古包头市九原区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150221', '内蒙古土默特右旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150222', '内蒙古固阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150223', '内蒙古达尔罕茂明安联合旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150300', '内蒙古乌海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150301', '内蒙古乌海市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150302', '内蒙古乌海市海勃湾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150303', '内蒙古乌海市海南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150304', '内蒙古乌海市乌达区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150400', '内蒙古赤峰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150401', '内蒙古赤峰市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150402', '内蒙古赤峰市红山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150403', '内蒙古赤峰市元宝山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150404', '内蒙古赤峰市松山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150421', '内蒙古阿鲁科尔沁旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150422', '内蒙古巴林左旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150423', '内蒙古巴林右旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150424', '内蒙古林西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150425', '内蒙古克什克腾旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150426', '内蒙古翁牛特旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150428', '内蒙古喀喇沁旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150429', '内蒙古宁城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150430', '内蒙古敖汉旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150500', '内蒙古通辽市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150501', '内蒙古通辽市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150502', '内蒙古通辽市科尔沁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150521', '内蒙古科尔沁左翼中旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150522', '内蒙古科尔沁左翼后旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150523', '内蒙古开鲁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150524', '内蒙古库伦旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150525', '内蒙古奈曼旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150526', '内蒙古扎鲁特旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150581', '内蒙古霍林郭勒市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150600', '内蒙古鄂尔多斯市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150602', '内蒙古鄂尔多斯市东胜区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150621', '内蒙古达拉特旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150622', '内蒙古准格尔旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150623', '内蒙古鄂托克前旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150624', '内蒙古鄂托克旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150625', '内蒙古杭锦旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150626', '内蒙古乌审旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150627', '内蒙古伊金霍洛旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150700', '内蒙古呼伦贝尔市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150701', '内蒙古呼伦贝尔市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150702', '内蒙古呼伦贝尔市海拉尔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150721', '内蒙古阿荣旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150722', '内蒙古莫力达瓦达斡尔族自治旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150723', '内蒙古鄂伦春自治旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150724', '内蒙古鄂温克族自治旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150725', '内蒙古陈巴尔虎旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150726', '内蒙古新巴尔虎左旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150727', '内蒙古新巴尔虎右旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150781', '内蒙古满洲里市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150782', '内蒙古牙克石市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150783', '内蒙古扎兰屯市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150784', '内蒙古额尔古纳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150785', '内蒙古根河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150800', '内蒙古巴彦淖尔市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150801', '内蒙古巴彦淖尔市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150802', '内蒙古巴彦淖尔市临河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150821', '内蒙古五原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150822', '内蒙古磴口县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150823', '内蒙古乌拉特前旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150824', '内蒙古乌拉特中旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150825', '内蒙古乌拉特后旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150826', '内蒙古杭锦后旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150900', '内蒙古乌兰察布市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150901', '内蒙古乌兰察布市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150902', '内蒙古乌兰察布市集宁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150921', '内蒙古卓资县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150922', '内蒙古化德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150923', '内蒙古商都县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150924', '内蒙古兴和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150925', '内蒙古凉城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150926', '内蒙古察哈尔右翼前旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150927', '内蒙古察哈尔右翼中旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150928', '内蒙古察哈尔右翼后旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150929', '内蒙古四子王旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('150981', '内蒙古丰镇市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152200', '内蒙古兴安盟', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152201', '内蒙古乌兰浩特市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152202', '内蒙古阿尔山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152221', '内蒙古科尔沁右翼前旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152222', '内蒙古科尔沁右翼中旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152223', '内蒙古扎赉特旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152224', '内蒙古突泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152500', '内蒙古锡林郭勒盟', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152501', '内蒙古二连浩特市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152502', '内蒙古锡林浩特市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152522', '内蒙古阿巴嘎旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152523', '内蒙古苏尼特左旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152524', '内蒙古苏尼特右旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152525', '内蒙古东乌珠穆沁旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152526', '内蒙古西乌珠穆沁旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152527', '内蒙古太仆寺旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152528', '内蒙古镶黄旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152529', '内蒙古正镶白旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152530', '内蒙古正蓝旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152531', '内蒙古多伦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152900', '内蒙古阿拉善盟', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152921', '内蒙古阿拉善左旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152922', '内蒙古阿拉善右旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('152923', '内蒙古额济纳旗', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210000', '辽宁省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210100', '辽宁省沈阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210101', '辽宁省沈阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210102', '辽宁省沈阳市和平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210103', '辽宁省沈阳市沈河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210104', '辽宁省沈阳市大东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210105', '辽宁省沈阳市皇姑区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210106', '辽宁省沈阳市铁西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210111', '辽宁省沈阳市苏家屯区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210112', '辽宁省沈阳市东陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210113', '辽宁省沈阳市新城子区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210114', '辽宁省沈阳市于洪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210122', '辽宁省辽中县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210123', '辽宁省康平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210124', '辽宁省法库县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210181', '辽宁省新民市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210200', '辽宁省大连市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210201', '辽宁省大连市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210202', '辽宁省大连市中山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210203', '辽宁省大连市西岗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210204', '辽宁省大连市沙河口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210211', '辽宁省大连市甘井子区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210212', '辽宁省大连市旅顺口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210213', '辽宁省大连市金州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210224', '辽宁省长海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210281', '辽宁省瓦房店市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210282', '辽宁省普兰店市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210283', '辽宁省庄河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210300', '辽宁省鞍山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210301', '辽宁省鞍山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210302', '辽宁省鞍山市铁东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210303', '辽宁省鞍山市铁西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210304', '辽宁省鞍山市立山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210311', '辽宁省鞍山市千山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411525', '河南省固始县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320402', '江苏省常州市天宁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320404', '江苏省常州市钟楼区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320405', '江苏省常州市戚墅堰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320411', '江苏省常州市新北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320412', '江苏省常州市武进区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320481', '江苏省溧阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320482', '江苏省金坛市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320500', '江苏省苏州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320501', '江苏省苏州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320502', '江苏省苏州市沧浪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320503', '江苏省苏州市平江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320504', '江苏省苏州市金阊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320505', '江苏省苏州市虎丘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320506', '江苏省苏州市吴中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320507', '江苏省苏州市相城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320581', '江苏省常熟市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320582', '江苏省张家港市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320583', '江苏省昆山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320584', '江苏省吴江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320585', '江苏省太仓市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320600', '江苏省南通市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320601', '江苏省南通市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320602', '江苏省南通市崇川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320611', '江苏省南通市港闸区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320621', '江苏省海安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320623', '江苏省如东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320681', '江苏省启东市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320682', '江苏省如皋市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320683', '江苏省通州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320684', '江苏省海门市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320700', '江苏省连云港市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320701', '江苏省连云港市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320703', '江苏省连云港市连云区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320705', '江苏省连云港市新浦区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320706', '江苏省连云港市海州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320721', '江苏省赣榆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320722', '江苏省东海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320723', '江苏省灌云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320724', '江苏省灌南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411322', '河南省方城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411323', '河南省西峡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411324', '河南省镇平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411325', '河南省内乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411326', '河南省淅川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411327', '河南省社旗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411328', '河南省唐河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411329', '河南省新野县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411330', '河南省桐柏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411381', '河南省邓州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411400', '河南省商丘市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411401', '河南省商丘市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411402', '河南省商丘市梁园区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411403', '河南省商丘市睢阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411421', '河南省民权县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411422', '河南省睢县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411423', '河南省宁陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320800', '江苏省淮安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320801', '江苏省淮安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320802', '江苏省淮安市清河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320803', '江苏省淮安市楚州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320804', '江苏省淮安市淮阴区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320811', '江苏省淮安市清浦区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320826', '江苏省涟水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320829', '江苏省洪泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320830', '江苏省盱眙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320831', '江苏省金湖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320900', '江苏省盐城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320901', '江苏省盐城市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320902', '江苏省盐城市亭湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320903', '江苏省盐城市盐都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320921', '江苏省响水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320922', '江苏省滨海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320923', '江苏省阜宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320924', '江苏省射阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320925', '江苏省建湖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320981', '江苏省东台市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320982', '江苏省大丰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321000', '江苏省扬州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321001', '江苏省扬州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321002', '江苏省扬州市广陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321003', '江苏省扬州市邗江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321011', '江苏省扬州市郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321023', '江苏省宝应县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321081', '江苏省仪征市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321084', '江苏省高邮市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321088', '江苏省江都市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321100', '江苏省镇江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321101', '江苏省镇江市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321102', '江苏省镇江市京口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321111', '江苏省镇江市润州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321112', '江苏省镇江市丹徒区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321181', '江苏省丹阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321182', '江苏省扬中市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321183', '江苏省句容市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321200', '江苏省泰州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321201', '江苏省泰州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321202', '江苏省泰州市海陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321203', '江苏省泰州市高港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321281', '江苏省兴化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321282', '江苏省靖江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321283', '江苏省泰兴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321284', '江苏省姜堰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321300', '江苏省宿迁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321301', '江苏省宿迁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321302', '江苏省宿迁市宿城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321311', '江苏省宿迁市宿豫区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321322', '江苏省沭阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321323', '江苏省泗阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('321324', '江苏省泗洪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330000', '浙江省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330100', '浙江省杭州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330101', '浙江省杭州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330102', '浙江省杭州市上城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330103', '浙江省杭州市下城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330104', '浙江省杭州市江干区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330105', '浙江省杭州市拱墅区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330106', '浙江省杭州市西湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330108', '浙江省杭州市滨江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330109', '浙江省杭州市萧山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330110', '浙江省杭州市余杭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330122', '浙江省桐庐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330127', '浙江省淳安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330182', '浙江省建德市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330183', '浙江省富阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330185', '浙江省临安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330200', '浙江省宁波市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330201', '浙江省宁波市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330203', '浙江省宁波市海曙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330204', '浙江省宁波市江东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330205', '浙江省宁波市江北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330206', '浙江省宁波市北仑区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330211', '浙江省宁波市镇海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330212', '浙江省宁波市鄞州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330225', '浙江省象山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330226', '浙江省宁海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330281', '浙江省余姚市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330282', '浙江省慈溪市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330283', '浙江省奉化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330300', '浙江省温州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330301', '浙江省温州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330302', '浙江省温州市鹿城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330303', '浙江省温州市龙湾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330304', '浙江省温州市瓯海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330322', '浙江省洞头县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330324', '浙江省永嘉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330326', '浙江省平阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330327', '浙江省苍南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330328', '浙江省文成县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330329', '浙江省泰顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330381', '浙江省瑞安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330382', '浙江省乐清市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330400', '浙江省嘉兴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330401', '浙江省嘉兴市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330402', '浙江省嘉兴市秀城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330411', '浙江省嘉兴市秀洲区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330421', '浙江省嘉善县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330424', '浙江省海盐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330481', '浙江省海宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330482', '浙江省平湖市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330483', '浙江省桐乡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330500', '浙江省湖州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330501', '浙江省湖州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330502', '浙江省湖州市吴兴区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330503', '浙江省湖州市南浔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330521', '浙江省德清县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330522', '浙江省长兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330523', '浙江省安吉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330600', '浙江省绍兴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330601', '浙江省绍兴市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330602', '浙江省绍兴市越城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330621', '浙江省绍兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330624', '浙江省新昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330681', '浙江省诸暨市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330682', '浙江省上虞市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330683', '浙江省嵊州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330700', '浙江省金华市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330701', '浙江省金华市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330702', '浙江省金华市婺城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330703', '浙江省金华市金东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330723', '浙江省武义县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330726', '浙江省浦江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330727', '浙江省磐安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330781', '浙江省兰溪市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330782', '浙江省义乌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330783', '浙江省东阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330784', '浙江省永康市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330800', '浙江省衢州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330801', '浙江省衢州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330802', '浙江省衢州市柯城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330803', '浙江省衢州市衢江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330822', '浙江省常山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330824', '浙江省开化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330825', '浙江省龙游县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330881', '浙江省江山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330900', '浙江省舟山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330901', '浙江省舟山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330902', '浙江省舟山市定海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330903', '浙江省舟山市普陀区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330921', '浙江省岱山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('330922', '浙江省嵊泗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331000', '浙江省台州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331001', '浙江省台州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331002', '浙江省台州市椒江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331003', '浙江省台州市黄岩区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331004', '浙江省台州市路桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331021', '浙江省玉环县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331022', '浙江省三门县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331023', '浙江省天台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331024', '浙江省仙居县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331081', '浙江省温岭市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331082', '浙江省临海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331100', '浙江省丽水市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331101', '浙江省丽水市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331102', '浙江省丽水市莲都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331121', '浙江省青田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331122', '浙江省缙云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331123', '浙江省遂昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331124', '浙江省松阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331125', '浙江省云和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331126', '浙江省庆元县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331127', '浙江省景宁畲族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('331181', '浙江省龙泉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340000', '安徽省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340100', '安徽省合肥市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340101', '安徽省合肥市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340102', '安徽省合肥市瑶海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340103', '安徽省合肥市庐阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340104', '安徽省合肥市蜀山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340111', '安徽省合肥市包河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340121', '安徽省长丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340122', '安徽省肥东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340123', '安徽省肥西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340200', '安徽省芜湖市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340201', '安徽省芜湖市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340202', '安徽省芜湖市镜湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340203', '安徽省芜湖市马塘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340204', '安徽省芜湖市新芜区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340207', '安徽省芜湖市鸠江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340221', '安徽省芜湖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340222', '安徽省繁昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340223', '安徽省南陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340300', '安徽省蚌埠市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340301', '安徽省蚌埠市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340302', '安徽省蚌埠市龙子湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340303', '安徽省蚌埠市蚌山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340304', '安徽省蚌埠市禹会区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340311', '安徽省蚌埠市淮上区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340321', '安徽省怀远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340322', '安徽省五河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340323', '安徽省固镇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340400', '安徽省淮南市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340401', '安徽省淮南市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340402', '安徽省淮南市大通区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340403', '安徽省淮南市田家庵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340404', '安徽省淮南市谢家集区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340405', '安徽省淮南市八公山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340406', '安徽省淮南市潘集区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340421', '安徽省凤台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340500', '安徽省马鞍山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340501', '安徽省马鞍山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340502', '安徽省马鞍山市金家庄区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340503', '安徽省马鞍山市花山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340504', '安徽省马鞍山市雨山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130683', '河北省安国市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130684', '河北省高碑店市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130700', '河北省张家口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130701', '河北省张家口市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130702', '河北省张家口市桥东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130703', '河北省张家口市桥西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130705', '河北省张家口市宣化区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130706', '河北省张家口市下花园区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130721', '河北省宣化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130722', '河北省张北县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130723', '河北省康保县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130724', '河北省沽源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130725', '河北省尚义县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130726', '河北省蔚县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130727', '河北省阳原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130728', '河北省怀安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130729', '河北省万全县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130730', '河北省怀来县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130731', '河北省涿鹿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130732', '河北省赤城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130733', '河北省崇礼县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130800', '河北省承德市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130801', '河北省承德市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130802', '河北省承德市双桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130803', '河北省承德市双滦区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130804', '河北省承德市鹰手营子矿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130821', '河北省承德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130822', '河北省兴隆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130823', '河北省平泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130824', '河北省滦平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130825', '河北省隆化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130826', '河北省丰宁满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130827', '河北省宽城满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130828', '河北省围场满族蒙古族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130900', '河北省沧州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130901', '河北省沧州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130902', '河北省沧州市新华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130903', '河北省沧州市运河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130921', '河北省沧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130922', '河北省青县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130923', '河北省东光县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130924', '河北省海兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130925', '河北省盐山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130926', '河北省肃宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130927', '河北省南皮县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130928', '河北省吴桥县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130929', '河北省献县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130930', '河北省孟村回族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130981', '河北省泊头市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130982', '河北省任丘市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130983', '河北省黄骅市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('130984', '河北省河间市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131000', '河北省廊坊市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131001', '河北省廊坊市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131002', '河北省廊坊市安次区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131003', '河北省廊坊市广阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411424', '河南省柘城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411425', '河南省虞城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411426', '河南省夏邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411481', '河南省永城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411500', '河南省信阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411501', '河南省信阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411502', '河南省信阳市师河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411503', '河南省信阳市平桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411521', '河南省罗山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411522', '河南省光山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411523', '河南省新县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411524', '河南省商城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652822', '新疆轮台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652823', '新疆尉犁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652824', '新疆若羌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652825', '新疆且末县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652826', '新疆焉耆回族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652827', '新疆和静县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652828', '新疆和硕县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652829', '新疆博湖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652900', '新疆阿克苏地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652901', '新疆阿克苏市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652922', '新疆温宿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652923', '新疆库车县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652924', '新疆沙雅县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652925', '新疆新和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652926', '新疆拜城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652927', '新疆乌什县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652928', '新疆阿瓦提县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652929', '新疆柯坪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653000', '新疆克孜勒苏柯尔克孜自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653001', '新疆阿图什市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653022', '新疆阿克陶县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653023', '新疆阿合奇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653024', '新疆乌恰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653100', '新疆喀什地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653101', '新疆喀什市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653121', '新疆疏附县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653122', '新疆疏勒县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653123', '新疆英吉沙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653124', '新疆泽普县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653125', '新疆莎车县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653126', '新疆叶城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653127', '新疆麦盖提县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653128', '新疆岳普湖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653129', '新疆伽师县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653130', '新疆巴楚县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653131', '新疆塔什库尔干塔吉克自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653200', '新疆和田地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653201', '新疆和田市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653221', '新疆和田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653222', '新疆墨玉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653223', '新疆皮山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653224', '新疆洛浦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653225', '新疆策勒县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653226', '新疆于田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('653227', '新疆民丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654000', '新疆伊犁哈萨克自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654002', '新疆伊宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654003', '新疆奎屯市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654021', '新疆伊宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654022', '新疆察布查尔锡伯自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654023', '新疆霍城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654024', '新疆巩留县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654025', '新疆新源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654026', '新疆昭苏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654027', '新疆特克斯县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654028', '新疆尼勒克县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654200', '新疆塔城地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654201', '新疆塔城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654202', '新疆乌苏市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654221', '新疆额敏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654223', '新疆沙湾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654224', '新疆托里县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654225', '新疆裕民县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654226', '新疆和布克赛尔蒙古自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654300', '新疆阿勒泰地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654301', '新疆阿勒泰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654321', '新疆布尔津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654322', '新疆富蕴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654323', '新疆福海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654324', '新疆哈巴河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654325', '新疆青河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('654326', '新疆吉木乃县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('659000', '新疆省直辖行政单位', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('659001', '新疆石河子市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('659002', '新疆阿拉尔市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('659003', '新疆图木舒克市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('659004', '新疆五家渠市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('710000', '台湾省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('810000', '香港特别行政区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('820000', '澳门特别行政区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460101', '海南省海口市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460105', '海南省海口市秀英区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460106', '海南省海口市龙华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460107', '海南省海口市琼山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460108', '海南省海口市美兰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460200', '海南省三亚市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460201', '海南省三亚市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469000', '海南省省直辖县级行政单位', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469001', '海南省五指山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469002', '海南省琼海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469003', '海南省儋州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469005', '海南省文昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469006', '海南省万宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469007', '海南省东方市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469025', '海南省定安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469026', '海南省屯昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469027', '海南省澄迈县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469028', '海南省临高县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469030', '海南省白沙黎族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469031', '海南省昌江黎族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469033', '海南省乐东黎族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469034', '海南省陵水黎族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469035', '海南省保亭黎族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469036', '海南省琼中黎族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469037', '海南省西沙群岛', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469038', '海南省南沙群岛', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('469039', '海南省中沙群岛的岛礁及其海域', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500000', '重庆市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500100', '重庆市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500101', '重庆市万州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500102', '重庆市涪陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500103', '重庆市渝中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500104', '重庆市大渡口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500105', '重庆市江北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500106', '重庆市沙坪坝区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500107', '重庆市九龙坡区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500108', '重庆市南岸区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500109', '重庆市北碚区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500110', '重庆市万盛区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500111', '重庆市双桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500112', '重庆市渝北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500113', '重庆市巴南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500114', '重庆市黔江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500115', '重庆市长寿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500200', '重庆市县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500222', '重庆市綦江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500223', '重庆市潼南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500224', '重庆市铜梁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500225', '重庆市大足县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500226', '重庆市荣昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500227', '重庆市璧山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500228', '重庆市梁平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500229', '重庆市城口县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500230', '重庆市丰都县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500231', '重庆市垫江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500232', '重庆市武隆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500233', '重庆市忠县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500234', '重庆市开县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500235', '重庆市云阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500236', '重庆市奉节县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500237', '重庆市巫山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500238', '重庆市巫溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500240', '重庆市石柱土家族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500241', '重庆市秀山土家族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500242', '重庆市酉阳土家族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500243', '重庆市彭水苗族土家族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500300', '重庆市市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500381', '重庆市江津市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500382', '重庆市合川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500383', '重庆市永川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('500384', '重庆市南川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510000', '四川省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510100', '四川省成都市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510101', '四川省成都市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510104', '四川省成都市锦江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510105', '四川省成都市青羊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510106', '四川省成都市金牛区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510107', '四川省成都市武侯区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510108', '四川省成都市成华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510112', '四川省成都市龙泉驿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510113', '四川省成都市青白江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510114', '四川省成都市新都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510115', '四川省成都市温江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510121', '四川省金堂县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510122', '四川省双流县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510124', '四川省郫县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510129', '四川省大邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510131', '四川省蒲江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510132', '四川省新津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510181', '四川省都江堰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510182', '四川省彭州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510183', '四川省邛崃市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510184', '四川省崇州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510300', '四川省自贡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510301', '四川省自贡市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510302', '四川省自贡市自流井区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510303', '四川省自贡市贡井区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510304', '四川省自贡市大安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510311', '四川省自贡市沿滩区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510321', '四川省荣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510322', '四川省富顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510400', '四川省攀枝花市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510401', '四川省攀枝花市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510402', '四川省攀枝花市东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510403', '四川省攀枝花市西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510411', '四川省攀枝花市仁和区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510421', '四川省米易县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510422', '四川省盐边县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510500', '四川省泸州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510501', '四川省泸州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510502', '四川省泸州市江阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510503', '四川省泸州市纳溪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510504', '四川省泸州市龙马潭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510521', '四川省泸县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510522', '四川省合江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510524', '四川省叙永县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510525', '四川省古蔺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510600', '四川省德阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510601', '四川省德阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510603', '四川省德阳市旌阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510623', '四川省中江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510626', '四川省罗江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510681', '四川省广汉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510682', '四川省什邡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510683', '四川省绵竹市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510700', '四川省绵阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510701', '四川省绵阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510703', '四川省绵阳市涪城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510704', '四川省绵阳市游仙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510722', '四川省三台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510723', '四川省盐亭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510724', '四川省安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510725', '四川省梓潼县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510726', '四川省北川羌族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510727', '四川省平武县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510781', '四川省江油市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510800', '四川省广元市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510801', '四川省广元市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510802', '四川省广元市市中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510811', '四川省广元市元坝区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510812', '四川省广元市朝天区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510821', '四川省旺苍县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510822', '四川省青川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510823', '四川省剑阁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510824', '四川省苍溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510900', '四川省遂宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510901', '四川省遂宁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510903', '四川省遂宁市船山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510904', '四川省遂宁市安居区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510921', '四川省蓬溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510922', '四川省射洪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('510923', '四川省大英县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511000', '四川省内江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511001', '四川省内江市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511002', '四川省内江市市中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511011', '四川省内江市东兴区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511024', '四川省威远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511025', '四川省资中县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511028', '四川省隆昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511100', '四川省乐山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511101', '四川省乐山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511102', '四川省乐山市市中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511111', '四川省乐山市沙湾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511112', '四川省乐山市五通桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511113', '四川省乐山市金口河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511123', '四川省犍为县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511124', '四川省井研县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511126', '四川省夹江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511129', '四川省沐川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511132', '四川省峨边彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511133', '四川省马边彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511181', '四川省峨眉山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511300', '四川省南充市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511301', '四川省南充市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511302', '四川省南充市顺庆区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511303', '四川省南充市高坪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511304', '四川省南充市嘉陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511321', '四川省南部县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131022', '河北省固安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131023', '河北省永清县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131024', '河北省香河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131025', '河北省大城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131026', '河北省文安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131028', '河北省大厂回族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131081', '河北省霸州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131082', '河北省三河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131100', '河北省衡水市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131101', '河北省衡水市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131102', '河北省衡水市桃城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131121', '河北省枣强县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131122', '河北省武邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131123', '河北省武强县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131124', '河北省饶阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131125', '河北省安平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131126', '河北省故城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131127', '河北省景县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131128', '河北省阜城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131181', '河北省冀州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('131182', '河北省深州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140000', '山西省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140100', '山西省太原市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140101', '山西省太原市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140105', '山西省太原市小店区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140106', '山西省太原市迎泽区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140107', '山西省太原市杏花岭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140108', '山西省太原市尖草坪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140109', '山西省太原市万柏林区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140110', '山西省太原市晋源区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140121', '山西省清徐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140122', '山西省阳曲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140123', '山西省娄烦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140181', '山西省古交市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140200', '山西省大同市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140201', '山西省大同市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140202', '山西省大同市城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140203', '山西省大同市矿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140211', '山西省大同市南郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140212', '山西省大同市新荣区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140221', '山西省阳高县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140222', '山西省天镇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140223', '山西省广灵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140224', '山西省灵丘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140225', '山西省浑源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140226', '山西省左云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140227', '山西省大同县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140300', '山西省阳泉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140301', '山西省阳泉市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140302', '山西省阳泉市城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140303', '山西省阳泉市矿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140311', '山西省阳泉市郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140321', '山西省平定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140322', '山西省盂县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140400', '山西省长治市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140401', '山西省长治市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('140402', '山西省长治市城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230604', '黑龙江省大庆市让胡路区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230605', '黑龙江省大庆市红岗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230606', '黑龙江省大庆市大同区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230621', '黑龙江省肇州县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230622', '黑龙江省肇源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230623', '黑龙江省林甸县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230624', '黑龙江省杜尔伯特蒙古族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230700', '黑龙江省伊春市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230701', '黑龙江省伊春市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230702', '黑龙江省伊春市伊春区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230703', '黑龙江省伊春市南岔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230704', '黑龙江省伊春市友好区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230705', '黑龙江省伊春市西林区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230706', '黑龙江省伊春市翠峦区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230707', '黑龙江省伊春市新青区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230708', '黑龙江省伊春市美溪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230709', '黑龙江省伊春市金山屯区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230710', '黑龙江省伊春市五营区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230711', '黑龙江省伊春市乌马河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230712', '黑龙江省伊春市汤旺河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230713', '黑龙江省伊春市带岭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230714', '黑龙江省伊春市乌伊岭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230715', '黑龙江省伊春市红星区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230716', '黑龙江省伊春市上甘岭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230722', '黑龙江省嘉荫县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230781', '黑龙江省铁力市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230800', '黑龙江省佳木斯市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230801', '黑龙江省佳木斯市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230802', '黑龙江省佳木斯市永红区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230803', '黑龙江省佳木斯市向阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230804', '黑龙江省佳木斯市前进区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230805', '黑龙江省佳木斯市东风区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230811', '黑龙江省佳木斯市郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230822', '黑龙江省桦南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230826', '黑龙江省桦川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230828', '黑龙江省汤原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230833', '黑龙江省抚远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230881', '黑龙江省同江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230882', '黑龙江省富锦市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230900', '黑龙江省七台河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230901', '黑龙江省七台河市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230902', '黑龙江省七台河市新兴区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230903', '黑龙江省七台河市桃山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230904', '黑龙江省七台河市茄子河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230921', '黑龙江省勃利县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231000', '黑龙江省牡丹江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231001', '黑龙江省牡丹江市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231002', '黑龙江省牡丹江市东安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231003', '黑龙江省牡丹江市阳明区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231004', '黑龙江省牡丹江市爱民区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231005', '黑龙江省牡丹江市西安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231024', '黑龙江省东宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231025', '黑龙江省林口县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231081', '黑龙江省绥芬河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231083', '黑龙江省海林市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231084', '黑龙江省宁安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231085', '黑龙江省穆棱市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231100', '黑龙江省黑河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231101', '黑龙江省黑河市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231102', '黑龙江省黑河市爱辉区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231121', '黑龙江省嫩江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231123', '黑龙江省逊克县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231124', '黑龙江省孙吴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231181', '黑龙江省北安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231182', '黑龙江省五大连池市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231200', '黑龙江省绥化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231201', '黑龙江省绥化市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231202', '黑龙江省绥化市北林区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231221', '黑龙江省望奎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231222', '黑龙江省兰西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231223', '黑龙江省青冈县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231224', '黑龙江省庆安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231225', '黑龙江省明水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231226', '黑龙江省绥棱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231281', '黑龙江省安达市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231282', '黑龙江省肇东市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('231283', '黑龙江省海伦市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('232700', '黑龙江省大兴安岭地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('232721', '黑龙江省呼玛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('232722', '黑龙江省塔河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('232723', '黑龙江省漠河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310000', '上海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310100', '上海市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310101', '上海市黄浦区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310103', '上海市卢湾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310104', '上海市徐汇区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310105', '上海市长宁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310106', '上海市静安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310107', '上海市普陀区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310108', '上海市闸北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310109', '上海市虹口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310110', '上海市杨浦区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310112', '上海市闵行区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310113', '上海市宝山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310114', '上海市嘉定区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310115', '上海市浦东新区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310116', '上海市金山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310117', '上海市松江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310118', '上海市青浦区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310119', '上海市南汇区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310120', '上海市奉贤区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310200', '上海市县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('310230', '上海市崇明县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320000', '江苏省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320100', '江苏省南京市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320101', '江苏省南京市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320102', '江苏省南京市玄武区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320103', '江苏省南京市白下区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320104', '江苏省南京市秦淮区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320105', '江苏省南京市建邺区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320106', '江苏省南京市鼓楼区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320107', '江苏省南京市下关区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320111', '江苏省南京市浦口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320113', '江苏省南京市栖霞区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320114', '江苏省南京市雨花台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320115', '江苏省南京市江宁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320116', '江苏省南京市六合区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320124', '江苏省溧水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320125', '江苏省高淳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320200', '江苏省无锡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320201', '江苏省无锡市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320202', '江苏省无锡市崇安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320203', '江苏省无锡市南长区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320204', '江苏省无锡市北塘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320205', '江苏省无锡市锡山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320206', '江苏省无锡市惠山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320211', '江苏省无锡市滨湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320281', '江苏省江阴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320282', '江苏省宜兴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320300', '江苏省徐州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320301', '江苏省徐州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320302', '江苏省徐州市鼓楼区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320303', '江苏省徐州市云龙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320304', '江苏省徐州市九里区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320305', '江苏省徐州市贾汪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320311', '江苏省徐州市泉山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320321', '江苏省丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320322', '江苏省沛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320323', '江苏省铜山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320324', '江苏省睢宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320381', '江苏省新沂市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320382', '江苏省邳州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320400', '江苏省常州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('320401', '江苏省常州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220882', '吉林省大安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222400', '吉林省延边朝鲜族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222401', '吉林省延吉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222402', '吉林省图们市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222403', '吉林省敦化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222404', '吉林省珲春市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222405', '吉林省龙井市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222406', '吉林省和龙市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222424', '吉林省汪清县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('222426', '吉林省安图县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230000', '黑龙江省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230100', '黑龙江省哈尔滨市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230101', '黑龙江省哈尔滨市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230102', '黑龙江省哈尔滨市道里区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230103', '黑龙江省哈尔滨市南岗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230104', '黑龙江省哈尔滨市道外区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230106', '黑龙江省哈尔滨市香坊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230107', '黑龙江省哈尔滨市动力区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230108', '黑龙江省哈尔滨市平房区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230109', '黑龙江省哈尔滨市松北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230111', '黑龙江省哈尔滨市呼兰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230123', '黑龙江省依兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230124', '黑龙江省方正县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230125', '黑龙江省宾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230126', '黑龙江省巴彦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230127', '黑龙江省木兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230128', '黑龙江省通河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230129', '黑龙江省延寿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230181', '黑龙江省阿城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230182', '黑龙江省双城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230183', '黑龙江省尚志市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230184', '黑龙江省五常市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230200', '黑龙江省齐齐哈尔市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230201', '黑龙江省齐齐哈尔市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230202', '黑龙江省齐齐哈尔市龙沙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230203', '黑龙江省齐齐哈尔市建华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230204', '黑龙江省齐齐哈尔市铁锋区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230205', '黑龙江省齐齐哈尔市昂昂溪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230206', '黑龙江省齐齐哈尔市富拉尔基区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230207', '黑龙江省齐齐哈尔市碾子山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230208', '黑龙江省齐齐哈尔市梅里斯达斡尔族区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230221', '黑龙江省龙江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230223', '黑龙江省依安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230224', '黑龙江省泰来县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230225', '黑龙江省甘南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230227', '黑龙江省富裕县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230229', '黑龙江省克山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230230', '黑龙江省克东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230231', '黑龙江省拜泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('230281', '黑龙江省讷河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511324', '四川省仪陇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511325', '四川省西充县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511381', '四川省阆中市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511400', '四川省眉山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511401', '四川省眉山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511402', '四川省眉山市东坡区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511421', '四川省仁寿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511422', '四川省彭山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511423', '四川省洪雅县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350303', '福建省莆田市涵江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350304', '福建省莆田市荔城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350305', '福建省莆田市秀屿区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350322', '福建省仙游县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350400', '福建省三明市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350401', '福建省三明市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350402', '福建省三明市梅列区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350403', '福建省三明市三元区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350421', '福建省明溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350423', '福建省清流县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350424', '福建省宁化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350425', '福建省大田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350426', '福建省尤溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350427', '福建省沙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350428', '福建省将乐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350429', '福建省泰宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350430', '福建省建宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350481', '福建省永安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350500', '福建省泉州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350501', '福建省泉州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350502', '福建省泉州市鲤城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350503', '福建省泉州市丰泽区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350504', '福建省泉州市洛江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350505', '福建省泉州市泉港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350521', '福建省惠安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350524', '福建省安溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350525', '福建省永春县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350526', '福建省德化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350527', '福建省金门县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350581', '福建省石狮市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350582', '福建省晋江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350583', '福建省南安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350600', '福建省漳州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350601', '福建省漳州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350602', '福建省漳州市芗城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350603', '福建省漳州市龙文区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350622', '福建省云霄县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350623', '福建省漳浦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350624', '福建省诏安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350625', '福建省长泰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350626', '福建省东山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350627', '福建省南靖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350628', '福建省平和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350629', '福建省华安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350681', '福建省龙海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350700', '福建省南平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350701', '福建省南平市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350702', '福建省南平市延平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350721', '福建省顺昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350722', '福建省浦城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350723', '福建省光泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350724', '福建省松溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350725', '福建省政和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350781', '福建省邵武市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350782', '福建省武夷山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350783', '福建省建瓯市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350784', '福建省建阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350800', '福建省龙岩市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350801', '福建省龙岩市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350802', '福建省龙岩市新罗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350821', '福建省长汀县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350822', '福建省永定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350823', '福建省上杭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350824', '福建省武平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350825', '福建省连城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350881', '福建省漳平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350900', '福建省宁德市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350901', '福建省宁德市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350902', '福建省宁德市蕉城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350921', '福建省霞浦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350922', '福建省古田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350923', '福建省屏南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350924', '福建省寿宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350925', '福建省周宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350926', '福建省柘荣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350981', '福建省福安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350982', '福建省福鼎市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360000', '江西省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360100', '江西省南昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360101', '江西省南昌市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360102', '江西省南昌市东湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360103', '江西省南昌市西湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360104', '江西省南昌市青云谱区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360105', '江西省南昌市湾里区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360111', '江西省南昌市青山湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360121', '江西省南昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360122', '江西省新建县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360123', '江西省安义县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360124', '江西省进贤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360200', '江西省景德镇市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360201', '江西省景德镇市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360202', '江西省景德镇市昌江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360203', '江西省景德镇市珠山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360222', '江西省浮梁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360281', '江西省乐平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360300', '江西省萍乡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360301', '江西省萍乡市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360302', '江西省萍乡市安源区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360313', '江西省萍乡市湘东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360321', '江西省莲花县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360322', '江西省上栗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360323', '江西省芦溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360400', '江西省九江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360401', '江西省九江市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360402', '江西省九江市庐山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360403', '江西省九江市浔阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360421', '江西省九江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360423', '江西省武宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360424', '江西省修水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360425', '江西省永修县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360426', '江西省德安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360427', '江西省星子县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360428', '江西省都昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360429', '江西省湖口县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360430', '江西省彭泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360481', '江西省瑞昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360500', '江西省新余市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360501', '江西省新余市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360502', '江西省新余市渝水区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360521', '江西省分宜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360600', '江西省鹰潭市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360601', '江西省鹰潭市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360602', '江西省鹰潭市月湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360622', '江西省余江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360681', '江西省贵溪市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360700', '江西省赣州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360701', '江西省赣州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360702', '江西省赣州市章贡区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360721', '江西省赣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360722', '江西省信丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360723', '江西省大余县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360724', '江西省上犹县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360725', '江西省崇义县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360726', '江西省安远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360727', '江西省龙南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360728', '江西省定南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360729', '江西省全南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360730', '江西省宁都县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360731', '江西省于都县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360732', '江西省兴国县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360733', '江西省会昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360734', '江西省寻乌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360735', '江西省石城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360781', '江西省瑞金市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360782', '江西省南康市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360800', '江西省吉安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360801', '江西省吉安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360802', '江西省吉安市吉州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360803', '江西省吉安市青原区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360821', '江西省吉安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360822', '江西省吉水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360823', '江西省峡江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360824', '江西省新干县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360825', '江西省永丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360826', '江西省泰和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360827', '江西省遂川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360828', '江西省万安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360829', '江西省安福县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360830', '江西省永新县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360881', '江西省井冈山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360900', '江西省宜春市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360901', '江西省宜春市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532623', '云南省西畴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532624', '云南省麻栗坡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532625', '云南省马关县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532626', '云南省丘北县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532627', '云南省广南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532628', '云南省富宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532800', '云南省西双版纳傣族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532801', '云南省景洪市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532822', '云南省勐海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532823', '云南省勐腊县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532900', '云南省大理白族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532901', '云南省大理市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532922', '云南省漾濞彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532923', '云南省祥云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532924', '云南省宾川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532925', '云南省弥渡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532926', '云南省南涧彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532927', '云南省巍山彝族回族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532928', '云南省永平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532929', '云南省云龙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532930', '云南省洱源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532931', '云南省剑川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532932', '云南省鹤庆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533100', '云南省德宏傣族景颇族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533102', '云南省瑞丽市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533103', '云南省潞西市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533122', '云南省梁河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533123', '云南省盈江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533124', '云南省陇川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533300', '云南省怒江傈僳族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533321', '云南省泸水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533323', '云南省福贡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533324', '云南省贡山独龙族怒族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533325', '云南省兰坪白族普米族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533400', '云南省迪庆藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533421', '云南省香格里拉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533422', '云南省德钦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('533423', '云南省维西傈僳族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540000', '西藏自治区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540100', '西藏拉萨市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540101', '西藏拉萨市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540102', '西藏拉萨市城关区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540121', '西藏林周县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540122', '西藏当雄县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540123', '西藏尼木县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540124', '西藏曲水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540125', '西藏堆龙德庆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540126', '西藏达孜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('540127', '西藏墨竹工卡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542100', '西藏昌都地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542121', '西藏昌都县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542122', '西藏江达县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542123', '西藏贡觉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542124', '西藏类乌齐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542125', '西藏丁青县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542126', '西藏察雅县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542127', '西藏八宿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542128', '西藏左贡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542129', '西藏芒康县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542132', '西藏洛隆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542133', '西藏边坝县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542200', '西藏山南地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542221', '西藏乃东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542222', '西藏扎囊县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542223', '西藏贡嘎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542224', '西藏桑日县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542225', '西藏琼结县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542226', '西藏曲松县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542227', '西藏措美县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542228', '西藏洛扎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542229', '西藏加查县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542231', '西藏隆子县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542232', '西藏错那县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542233', '西藏浪卡子县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542300', '西藏日喀则地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542301', '西藏日喀则市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542322', '西藏南木林县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542323', '西藏江孜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542324', '西藏定日县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542325', '西藏萨迦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542326', '西藏拉孜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542327', '西藏昂仁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542328', '西藏谢通门县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542329', '西藏白朗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542330', '西藏仁布县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542331', '西藏康马县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542332', '西藏定结县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542333', '西藏仲巴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542334', '西藏亚东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542335', '西藏吉隆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542336', '西藏聂拉木县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542337', '西藏萨嘎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542338', '西藏岗巴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542400', '西藏那曲地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542421', '西藏那曲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542422', '西藏嘉黎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542423', '西藏比如县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542424', '西藏聂荣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542425', '西藏安多县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542426', '西藏申扎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542427', '西藏索县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542428', '西藏班戈县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542429', '西藏巴青县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542430', '西藏尼玛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511425', '四川省青神县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340825', '安徽省太湖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340826', '安徽省宿松县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340827', '安徽省望江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340828', '安徽省岳西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340881', '安徽省桐城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341000', '安徽省黄山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341001', '安徽省黄山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341002', '安徽省黄山市屯溪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341003', '安徽省黄山市黄山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341004', '安徽省黄山市徽州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341021', '安徽省歙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341022', '安徽省休宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341023', '安徽省黟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341024', '安徽省祁门县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341100', '安徽省滁州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341101', '安徽省滁州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341102', '安徽省滁州市琅琊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341103', '安徽省滁州市南谯区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341122', '安徽省来安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341124', '安徽省全椒县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341125', '安徽省定远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341126', '安徽省凤阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341181', '安徽省天长市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341182', '安徽省明光市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341200', '安徽省阜阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341201', '安徽省阜阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341202', '安徽省阜阳市颍州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341203', '安徽省阜阳市颍东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341204', '安徽省阜阳市颍泉区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341221', '安徽省临泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341222', '安徽省太和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341225', '安徽省阜南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341226', '安徽省颍上县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341282', '安徽省界首市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341300', '安徽省宿州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341301', '安徽省宿州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341302', '安徽省宿州市墉桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341321', '安徽省砀山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341322', '安徽省萧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341323', '安徽省灵璧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341324', '安徽省泗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341400', '安徽省巢湖市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341401', '安徽省巢湖市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341402', '安徽省巢湖市居巢区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341421', '安徽省庐江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341422', '安徽省无为县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341423', '安徽省含山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341424', '安徽省和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341500', '安徽省六安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341501', '安徽省六安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341502', '安徽省六安市金安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341503', '安徽省六安市裕安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341521', '安徽省寿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341522', '安徽省霍邱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341523', '安徽省舒城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341524', '安徽省金寨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341525', '安徽省霍山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341600', '安徽省亳州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341601', '安徽省亳州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341602', '安徽省亳州市谯城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341621', '安徽省涡阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341622', '安徽省蒙城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341623', '安徽省利辛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341700', '安徽省池州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341701', '安徽省池州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341702', '安徽省池州市贵池区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341721', '安徽省东至县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341722', '安徽省石台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341723', '安徽省青阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341800', '安徽省宣城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341801', '安徽省宣城市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341802', '安徽省宣城市宣州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341821', '安徽省郎溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341822', '安徽省广德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341823', '安徽省泾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341824', '安徽省绩溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341825', '安徽省旌德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('341881', '安徽省宁国市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350000', '福建省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350100', '福建省福州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350101', '福建省福州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350102', '福建省福州市鼓楼区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350103', '福建省福州市台江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350104', '福建省福州市仓山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350105', '福建省福州市马尾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350111', '福建省福州市晋安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350121', '福建省闽侯县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350122', '福建省连江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350123', '福建省罗源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350124', '福建省闽清县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('350125', '福建省永泰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210321', '辽宁省台安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210323', '辽宁省岫岩满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210381', '辽宁省海城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210400', '辽宁省抚顺市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210401', '辽宁省抚顺市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210402', '辽宁省抚顺市新抚区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210403', '辽宁省抚顺市东洲区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210404', '辽宁省抚顺市望花区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210411', '辽宁省抚顺市顺城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210421', '辽宁省抚顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210422', '辽宁省新宾满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210423', '辽宁省清原满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210500', '辽宁省本溪市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210501', '辽宁省本溪市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210502', '辽宁省本溪市平山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210503', '辽宁省本溪市溪湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210504', '辽宁省本溪市明山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210505', '辽宁省本溪市南芬区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210521', '辽宁省本溪满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210522', '辽宁省桓仁满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210600', '辽宁省丹东市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210601', '辽宁省丹东市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210602', '辽宁省丹东市元宝区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210603', '辽宁省丹东市振兴区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210604', '辽宁省丹东市振安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210624', '辽宁省宽甸满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210681', '辽宁省东港市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210682', '辽宁省凤城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210700', '辽宁省锦州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210701', '辽宁省锦州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210702', '辽宁省锦州市古塔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210703', '辽宁省锦州市凌河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210711', '辽宁省锦州市太和区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210726', '辽宁省黑山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210727', '辽宁省义县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210781', '辽宁省凌海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210782', '辽宁省北宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210800', '辽宁省营口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210801', '辽宁省营口市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210802', '辽宁省营口市站前区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210803', '辽宁省营口市西市区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210804', '辽宁省营口市鲅鱼圈区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210811', '辽宁省营口市老边区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210881', '辽宁省盖州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210882', '辽宁省大石桥市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210900', '辽宁省阜新市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210901', '辽宁省阜新市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210902', '辽宁省阜新市海州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210903', '辽宁省阜新市新邱区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210904', '辽宁省阜新市太平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210905', '辽宁省阜新市清河门区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210911', '辽宁省阜新市细河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210921', '辽宁省阜新蒙古族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('210922', '辽宁省彰武县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211000', '辽宁省辽阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211001', '辽宁省辽阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211002', '辽宁省辽阳市白塔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211003', '辽宁省辽阳市文圣区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211004', '辽宁省辽阳市宏伟区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211005', '辽宁省辽阳市弓长岭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211011', '辽宁省辽阳市太子河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211021', '辽宁省辽阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211081', '辽宁省灯塔市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211100', '辽宁省盘锦市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211101', '辽宁省盘锦市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211102', '辽宁省盘锦市双台子区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211103', '辽宁省盘锦市兴隆台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211121', '辽宁省大洼县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211122', '辽宁省盘山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211200', '辽宁省铁岭市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211201', '辽宁省铁岭市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211202', '辽宁省铁岭市银州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211204', '辽宁省铁岭市清河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211221', '辽宁省铁岭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211223', '辽宁省西丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211224', '辽宁省昌图县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211281', '辽宁省调兵山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211282', '辽宁省开原市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211300', '辽宁省朝阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211301', '辽宁省朝阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211302', '辽宁省朝阳市双塔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211303', '辽宁省朝阳市龙城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211321', '辽宁省朝阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211322', '辽宁省建平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211324', '辽宁省喀喇沁左翼蒙古族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211381', '辽宁省北票市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211382', '辽宁省凌源市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211400', '辽宁省葫芦岛市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211401', '辽宁省葫芦岛市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211402', '辽宁省葫芦岛市连山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211403', '辽宁省葫芦岛市龙港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211404', '辽宁省葫芦岛市南票区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211421', '辽宁省绥中县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211422', '辽宁省建昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('211481', '辽宁省兴城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220000', '吉林省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220100', '吉林省长春市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220101', '吉林省长春市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220102', '吉林省长春市南关区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220103', '吉林省长春市宽城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220104', '吉林省长春市朝阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220105', '吉林省长春市二道区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220106', '吉林省长春市绿园区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220112', '吉林省长春市双阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220122', '吉林省农安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220181', '吉林省九台市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220182', '吉林省榆树市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220183', '吉林省德惠市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220200', '吉林省吉林市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220201', '吉林省吉林市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220202', '吉林省吉林市昌邑区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220203', '吉林省吉林市龙潭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220204', '吉林省吉林市船营区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220211', '吉林省吉林市丰满区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220221', '吉林省永吉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220281', '吉林省蛟河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220282', '吉林省桦甸市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220283', '吉林省舒兰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220284', '吉林省磐石市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220300', '吉林省四平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220301', '吉林省四平市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220302', '吉林省四平市铁西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220303', '吉林省四平市铁东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220322', '吉林省梨树县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220323', '吉林省伊通满族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220381', '吉林省公主岭市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220382', '吉林省双辽市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220400', '吉林省辽源市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220401', '吉林省辽源市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220402', '吉林省辽源市龙山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220403', '吉林省辽源市西安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220421', '吉林省东丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220422', '吉林省东辽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220500', '吉林省通化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220501', '吉林省通化市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220502', '吉林省通化市东昌区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220503', '吉林省通化市二道江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220521', '吉林省通化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220523', '吉林省辉南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220524', '吉林省柳河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220581', '吉林省梅河口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220582', '吉林省集安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220600', '吉林省白山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220601', '吉林省白山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220602', '吉林省白山市八道江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220621', '吉林省抚松县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220622', '吉林省靖宇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220623', '吉林省长白朝鲜族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220625', '吉林省江源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220681', '吉林省临江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220700', '吉林省松原市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220701', '吉林省松原市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220702', '吉林省松原市宁江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220721', '吉林省前郭尔罗斯蒙古族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220722', '吉林省长岭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220723', '吉林省乾安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220724', '吉林省扶余县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220800', '吉林省白城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220801', '吉林省白城市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220802', '吉林省白城市洮北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220821', '吉林省镇赉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220822', '吉林省通榆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('220881', '吉林省洮南市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451201', '广西河池市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451202', '广西河池市金城江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451221', '广西南丹县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451222', '广西天峨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451223', '广西凤山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451224', '广西东兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451225', '广西罗城仫佬族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451226', '广西环江毛南族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451227', '广西巴马瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451228', '广西都安瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451229', '广西大化瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451281', '广西宜州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451300', '广西来宾市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451301', '广西来宾市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451302', '广西来宾市兴宾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451321', '广西忻城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451322', '广西象州县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451323', '广西武宣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451324', '广西金秀瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451381', '广西合山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451400', '广西崇左市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451401', '广西崇左市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451402', '广西崇左市江洲区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451421', '广西扶绥县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451422', '广西宁明县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451423', '广西龙州县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451424', '广西大新县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451425', '广西天等县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451481', '广西凭祥市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460000', '海南省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('460100', '海南省海口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513424', '四川省德昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513425', '四川省会理县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513426', '四川省会东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513427', '四川省宁南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513428', '四川省普格县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513429', '四川省布拖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513430', '四川省金阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513431', '四川省昭觉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513432', '四川省喜德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513433', '四川省冕宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513434', '四川省越西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513435', '四川省甘洛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513436', '四川省美姑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513437', '四川省雷波县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520000', '贵州省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520100', '贵州省贵阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520101', '贵州省贵阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520102', '贵州省贵阳市南明区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520103', '贵州省贵阳市云岩区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520111', '贵州省贵阳市花溪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520112', '贵州省贵阳市乌当区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520113', '贵州省贵阳市白云区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520114', '贵州省贵阳市小河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520121', '贵州省开阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520122', '贵州省息烽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520123', '贵州省修文县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520181', '贵州省清镇市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520200', '贵州省六盘水市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520201', '贵州省六盘水市钟山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520203', '贵州省六盘水市六枝特区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520221', '贵州省水城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520222', '贵州省盘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520300', '贵州省遵义市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520301', '贵州省遵义市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520302', '贵州省遵义市红花岗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520303', '贵州省遵义市汇川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520321', '贵州省遵义县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520322', '贵州省桐梓县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520323', '贵州省绥阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520324', '贵州省正安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520325', '贵州省道真仡佬族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520326', '贵州省务川仡佬族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520327', '贵州省凤冈县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520328', '贵州省湄潭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520329', '贵州省余庆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520330', '贵州省习水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520381', '贵州省赤水市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520382', '贵州省仁怀市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520400', '贵州省安顺市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520401', '贵州省安顺市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520402', '贵州省安顺市西秀区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520421', '贵州省平坝县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520422', '贵州省普定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520423', '贵州省镇宁布依族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520424', '贵州省关岭布依族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('520425', '贵州省紫云苗族布依族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522200', '贵州省铜仁地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522201', '贵州省铜仁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522222', '贵州省江口县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522223', '贵州省玉屏侗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522224', '贵州省石阡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522225', '贵州省思南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522226', '贵州省印江土家族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522227', '贵州省德江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522228', '贵州省沿河土家族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522229', '贵州省松桃苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522230', '贵州省万山特区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522300', '贵州省黔西南布依族苗族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522301', '贵州省兴义市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522322', '贵州省兴仁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522323', '贵州省普安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522324', '贵州省晴隆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522325', '贵州省贞丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522326', '贵州省望谟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522327', '贵州省册亨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522328', '贵州省安龙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522400', '贵州省毕节地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522401', '贵州省毕节市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522422', '贵州省大方县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522423', '贵州省黔西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522424', '贵州省金沙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522425', '贵州省织金县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522426', '贵州省纳雍县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522427', '贵州省威宁彝族回族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522428', '贵州省赫章县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522600', '贵州省黔东南苗族侗族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522601', '贵州省凯里市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522622', '贵州省黄平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522623', '贵州省施秉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522624', '贵州省三穗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522625', '贵州省镇远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522626', '贵州省岑巩县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522627', '贵州省天柱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522628', '贵州省锦屏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522629', '贵州省剑河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522630', '贵州省台江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522631', '贵州省黎平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522632', '贵州省榕江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522633', '贵州省从江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522634', '贵州省雷山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522635', '贵州省麻江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522636', '贵州省丹寨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522700', '贵州省黔南布依族苗族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522701', '贵州省都匀市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522702', '贵州省福泉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522722', '贵州省荔波县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522723', '贵州省贵定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522725', '贵州省瓮安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522726', '贵州省独山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522727', '贵州省平塘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522728', '贵州省罗甸县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522729', '贵州省长顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522730', '贵州省龙里县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522731', '贵州省惠水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('522732', '贵州省三都水族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530000', '云南省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530100', '云南省昆明市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530101', '云南省昆明市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530102', '云南省昆明市五华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530103', '云南省昆明市盘龙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530111', '云南省昆明市官渡区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530112', '云南省昆明市西山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530113', '云南省昆明市东川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530121', '云南省呈贡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530122', '云南省晋宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530124', '云南省富民县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530125', '云南省宜良县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530126', '云南省石林彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530127', '云南省嵩明县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530128', '云南省禄劝彝族苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530129', '云南省寻甸回族彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530181', '云南省安宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530300', '云南省曲靖市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530301', '云南省曲靖市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530302', '云南省曲靖市麒麟区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530321', '云南省马龙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530322', '云南省陆良县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530323', '云南省师宗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530324', '云南省罗平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530325', '云南省富源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530326', '云南省会泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530328', '云南省沾益县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530381', '云南省宣威市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530400', '云南省玉溪市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530401', '云南省玉溪市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530402', '云南省玉溪市红塔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530421', '云南省江川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530422', '云南省澄江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530423', '云南省通海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530424', '云南省华宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530425', '云南省易门县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530426', '云南省峨山彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530427', '云南省新平彝族傣族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530428', '云南省元江哈尼族彝族傣族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530500', '云南省保山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530501', '云南省保山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530502', '云南省保山市隆阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530521', '云南省施甸县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530522', '云南省腾冲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530523', '云南省龙陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530524', '云南省昌宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530600', '云南省昭通市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530601', '云南省昭通市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530602', '云南省昭通市昭阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530621', '云南省鲁甸县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530622', '云南省巧家县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530623', '云南省盐津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530624', '云南省大关县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530625', '云南省永善县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530626', '云南省绥江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530627', '云南省镇雄县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530628', '云南省彝良县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530629', '云南省威信县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530630', '云南省水富县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530700', '云南省丽江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530701', '云南省丽江市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530702', '云南省丽江市古城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530721', '云南省玉龙纳西族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530722', '云南省永胜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530723', '云南省华坪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530724', '云南省宁蒗彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530800', '云南省思茅市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530801', '云南省思茅市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530802', '云南省思茅市翠云区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530821', '云南省普洱哈尼族彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530822', '云南省墨江哈尼族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530823', '云南省景东彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530824', '云南省景谷傣族彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530825', '云南省镇沅彝族哈尼族拉祜族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530826', '云南省江城哈尼族彝族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530827', '云南省孟连傣族拉祜族佤族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530828', '云南省澜沧拉祜族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530829', '云南省西盟佤族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530900', '云南省临沧市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530901', '云南省临沧市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530902', '云南省临沧市临翔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530921', '云南省凤庆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530922', '云南省云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530923', '云南省永德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530924', '云南省镇康县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530925', '云南省双江拉祜族佤族布朗族傣族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530926', '云南省耿马傣族佤族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('530927', '云南省沧源佤族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532300', '云南省楚雄彝族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532301', '云南省楚雄市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532322', '云南省双柏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532323', '云南省牟定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532324', '云南省南华县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532325', '云南省姚安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532326', '云南省大姚县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532327', '云南省永仁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532328', '云南省元谋县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532329', '云南省武定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532331', '云南省禄丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532500', '云南省红河哈尼族彝族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532501', '云南省个旧市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532502', '云南省开远市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532522', '云南省蒙自县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532523', '云南省屏边苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532524', '云南省建水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532525', '云南省石屏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532526', '云南省弥勒县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532527', '云南省泸西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532528', '云南省元阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532529', '云南省红河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532530', '云南省金平苗族瑶族傣族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532531', '云南省绿春县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532532', '云南省河口瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532600', '云南省文山壮族苗族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532621', '云南省文山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('532622', '云南省砚山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410482', '河南省汝州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410500', '河南省安阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410501', '河南省安阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410502', '河南省安阳市文峰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410503', '河南省安阳市北关区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451123', '广西富川瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410481', '河南省舞钢市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411526', '河南省潢川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411527', '河南省淮滨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411528', '河南省息县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411600', '河南省周口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411601', '河南省周口市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411602', '河南省周口市川汇区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411621', '河南省扶沟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411622', '河南省西华县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411623', '河南省商水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411624', '河南省沈丘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411625', '河南省郸城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411626', '河南省淮阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411627', '河南省太康县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411628', '河南省鹿邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411681', '河南省项城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411700', '河南省驻马店市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411701', '河南省驻马店市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411702', '河南省驻马店市驿城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411721', '河南省西平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411722', '河南省上蔡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411723', '河南省平舆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411724', '河南省正阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411725', '河南省确山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411726', '河南省泌阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411727', '河南省汝南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411728', '河南省遂平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411729', '河南省新蔡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420000', '湖北省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420100', '湖北省武汉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420101', '湖北省武汉市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420102', '湖北省武汉市江岸区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420103', '湖北省武汉市江汉区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420104', '湖北省武汉市乔口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420105', '湖北省武汉市汉阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420106', '湖北省武汉市武昌区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420107', '湖北省武汉市青山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420111', '湖北省武汉市洪山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420112', '湖北省武汉市东西湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420113', '湖北省武汉市汉南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420114', '湖北省武汉市蔡甸区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420115', '湖北省武汉市江夏区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420116', '湖北省武汉市黄陂区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420117', '湖北省武汉市新洲区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420200', '湖北省黄石市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420201', '湖北省黄石市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420202', '湖北省黄石市黄石港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420203', '湖北省黄石市西塞山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420204', '湖北省黄石市下陆区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420205', '湖北省黄石市铁山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420222', '湖北省阳新县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420281', '湖北省大冶市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420300', '湖北省十堰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420301', '湖北省十堰市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420302', '湖北省十堰市茅箭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420303', '湖北省十堰市张湾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420321', '湖北省郧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420322', '湖北省郧西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420323', '湖北省竹山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420324', '湖北省竹溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420325', '湖北省房县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420381', '湖北省丹江口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420500', '湖北省宜昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420501', '湖北省宜昌市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420502', '湖北省宜昌市西陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420503', '湖北省宜昌市伍家岗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420504', '湖北省宜昌市点军区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420505', '湖北省宜昌市虎亭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420506', '湖北省宜昌市夷陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420525', '湖北省远安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420526', '湖北省兴山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420527', '湖北省秭归县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420528', '湖北省长阳土家族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420529', '湖北省五峰土家族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420581', '湖北省宜都市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420582', '湖北省当阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420583', '湖北省枝江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420600', '湖北省襄樊市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420601', '湖北省襄樊市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420602', '湖北省襄樊市襄城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420606', '湖北省襄樊市樊城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420607', '湖北省襄樊市襄阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420624', '湖北省南漳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420625', '湖北省谷城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420626', '湖北省保康县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420682', '湖北省老河口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420683', '湖北省枣阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420684', '湖北省宜城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420700', '湖北省鄂州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420701', '湖北省鄂州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420702', '湖北省鄂州市梁子湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420703', '湖北省鄂州市华容区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420704', '湖北省鄂州市鄂城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420800', '湖北省荆门市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420801', '湖北省荆门市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420802', '湖北省荆门市东宝区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420804', '湖北省荆门市掇刀区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420821', '湖北省京山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420822', '湖北省沙洋县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420881', '湖北省钟祥市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420900', '湖北省孝感市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420901', '湖北省孝感市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420902', '湖北省孝感市孝南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420921', '湖北省孝昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420922', '湖北省大悟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420923', '湖北省云梦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420981', '湖北省应城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420982', '湖北省安陆市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('420984', '湖北省汉川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421000', '湖北省荆州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421001', '湖北省荆州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421002', '湖北省荆州市沙市区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421003', '湖北省荆州市荆州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421022', '湖北省公安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421023', '湖北省监利县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421024', '湖北省江陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421081', '湖北省石首市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421083', '湖北省洪湖市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421087', '湖北省松滋市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421100', '湖北省黄冈市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421101', '湖北省黄冈市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421102', '湖北省黄冈市黄州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421121', '湖北省团风县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421122', '湖北省红安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421123', '湖北省罗田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421124', '湖北省英山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421125', '湖北省浠水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421126', '湖北省蕲春县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421127', '湖北省黄梅县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421181', '湖北省麻城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421182', '湖北省武穴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421200', '湖北省咸宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421201', '湖北省咸宁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421202', '湖北省咸宁市咸安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421221', '湖北省嘉鱼县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421222', '湖北省通城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421223', '湖北省崇阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421224', '湖北省通山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421281', '湖北省赤壁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421300', '湖北省随州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421301', '湖北省随州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421302', '湖北省随州市曾都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('421381', '湖北省广水市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422800', '湖北省恩施土家族苗族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422801', '湖北省恩施市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422802', '湖北省利川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422822', '湖北省建始县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422823', '湖北省巴东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422825', '湖北省宣恩县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422826', '湖北省咸丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422827', '湖北省来凤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('422828', '湖北省鹤峰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('429000', '湖北省省直辖行政单位', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('429004', '湖北省仙桃市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('429005', '湖北省潜江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('429006', '湖北省天门市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('429021', '湖北省神农架林区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430000', '湖南省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430100', '湖南省长沙市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430101', '湖南省长沙市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430102', '湖南省长沙市芙蓉区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430103', '湖南省长沙市天心区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430104', '湖南省长沙市岳麓区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430105', '湖南省长沙市开福区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430111', '湖南省长沙市雨花区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430121', '湖南省长沙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430122', '湖南省望城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430124', '湖南省宁乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430181', '湖南省浏阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430200', '湖南省株洲市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430201', '湖南省株洲市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430202', '湖南省株洲市荷塘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430203', '湖南省株洲市芦淞区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430204', '湖南省株洲市石峰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430211', '湖南省株洲市天元区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430221', '湖南省株洲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430223', '湖南省攸县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430224', '湖南省茶陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430225', '湖南省炎陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430281', '湖南省醴陵市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430300', '湖南省湘潭市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430301', '湖南省湘潭市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430302', '湖南省湘潭市雨湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430304', '湖南省湘潭市岳塘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430321', '湖南省湘潭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430381', '湖南省湘乡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430382', '湖南省韶山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430400', '湖南省衡阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430401', '湖南省衡阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430405', '湖南省衡阳市珠晖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430406', '湖南省衡阳市雁峰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430407', '湖南省衡阳市石鼓区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430408', '湖南省衡阳市蒸湘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430412', '湖南省衡阳市南岳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430421', '湖南省衡阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430422', '湖南省衡南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430423', '湖南省衡山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430424', '湖南省衡东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430426', '湖南省祁东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430481', '湖南省耒阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430482', '湖南省常宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430500', '湖南省邵阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430501', '湖南省邵阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430502', '湖南省邵阳市双清区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430503', '湖南省邵阳市大祥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430511', '湖南省邵阳市北塔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430521', '湖南省邵东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430522', '湖南省新邵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430523', '湖南省邵阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430524', '湖南省隆回县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430525', '湖南省洞口县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430527', '湖南省绥宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430528', '湖南省新宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430529', '湖南省城步苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430581', '湖南省武冈市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430600', '湖南省岳阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430601', '湖南省岳阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430602', '湖南省岳阳市岳阳楼区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430603', '湖南省岳阳市云溪区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430611', '湖南省岳阳市君山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430621', '湖南省岳阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430623', '湖南省华容县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430624', '湖南省湘阴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430626', '湖南省平江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430681', '湖南省汨罗市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430682', '湖南省临湘市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430700', '湖南省常德市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430701', '湖南省常德市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430702', '湖南省常德市武陵区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430703', '湖南省常德市鼎城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430721', '湖南省安乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430722', '湖南省汉寿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430723', '湖南省澧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430724', '湖南省临澧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430725', '湖南省桃源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430726', '湖南省石门县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430781', '湖南省津市市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430800', '湖南省张家界市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430801', '湖南省张家界市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430802', '湖南省张家界市永定区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430811', '湖南省张家界市武陵源区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430821', '湖南省慈利县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430822', '湖南省桑植县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430900', '湖南省益阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430901', '湖南省益阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430902', '湖南省益阳市资阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430903', '湖南省益阳市赫山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430921', '湖南省南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430922', '湖南省桃江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430923', '湖南省安化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('430981', '湖南省沅江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431000', '湖南省郴州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431001', '湖南省郴州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431002', '湖南省郴州市北湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431003', '湖南省郴州市苏仙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431021', '湖南省桂阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431022', '湖南省宜章县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431023', '湖南省永兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431024', '湖南省嘉禾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431025', '湖南省临武县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431026', '湖南省汝城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431027', '湖南省桂东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431028', '湖南省安仁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431081', '湖南省资兴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431100', '湖南省永州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511424', '四川省丹棱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511500', '四川省宜宾市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511501', '四川省宜宾市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511502', '四川省宜宾市翠屏区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511521', '四川省宜宾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511522', '四川省南溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511523', '四川省江安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511524', '四川省长宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511525', '四川省高县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511526', '四川省珙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511527', '四川省筠连县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511528', '四川省兴文县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511529', '四川省屏山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511600', '四川省广安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511601', '四川省广安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511602', '四川省广安市广安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511621', '四川省岳池县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511622', '四川省武胜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511623', '四川省邻水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511681', '四川省华莹市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511700', '四川省达州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511701', '四川省达州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511702', '四川省达州市通川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511721', '四川省达县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511722', '四川省宣汉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511723', '四川省开江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511724', '四川省大竹县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511725', '四川省渠县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511781', '四川省万源市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511800', '四川省雅安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511801', '四川省雅安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511802', '四川省雅安市雨城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511821', '四川省名山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511822', '四川省荥经县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511823', '四川省汉源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511824', '四川省石棉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511825', '四川省天全县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511826', '四川省芦山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511827', '四川省宝兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511900', '四川省巴中市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511901', '四川省巴中市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511902', '四川省巴中市巴州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511921', '四川省通江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511922', '四川省南江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511923', '四川省平昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('512000', '四川省资阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('512001', '四川省资阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('512002', '四川省资阳市雁江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('512021', '四川省安岳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('512022', '四川省乐至县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('512081', '四川省简阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513200', '四川省阿坝藏族羌族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513221', '四川省汶川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513222', '四川省理县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513223', '四川省茂县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513224', '四川省松潘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513225', '四川省九寨沟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513226', '四川省金川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513227', '四川省小金县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513228', '四川省黑水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513229', '四川省马尔康县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513230', '四川省壤塘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513231', '四川省阿坝县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513232', '四川省若尔盖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513233', '四川省红原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513300', '四川省甘孜藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513321', '四川省康定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513322', '四川省泸定县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513323', '四川省丹巴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513324', '四川省九龙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513325', '四川省雅江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513326', '四川省道孚县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513327', '四川省炉霍县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513328', '四川省甘孜县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513329', '四川省新龙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513330', '四川省德格县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513331', '四川省白玉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513332', '四川省石渠县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513333', '四川省色达县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513334', '四川省理塘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513335', '四川省巴塘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513336', '四川省乡城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513337', '四川省稻城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513338', '四川省得荣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513400', '四川省凉山彝族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513401', '四川省西昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513422', '四川省木里藏族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('513423', '四川省盐源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440982', '广东省化州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440983', '广东省信宜市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441200', '广东省肇庆市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441201', '广东省肇庆市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441202', '广东省肇庆市端州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441203', '广东省肇庆市鼎湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441223', '广东省广宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441224', '广东省怀集县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441225', '广东省封开县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441226', '广东省德庆县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441283', '广东省高要市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441284', '广东省四会市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441300', '广东省惠州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441301', '广东省惠州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441302', '广东省惠州市惠城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441303', '广东省惠州市惠阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441322', '广东省博罗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441323', '广东省惠东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441324', '广东省龙门县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441400', '广东省梅州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441401', '广东省梅州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441402', '广东省梅州市梅江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441421', '广东省梅县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441422', '广东省大埔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441423', '广东省丰顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441424', '广东省五华县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441426', '广东省平远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441427', '广东省蕉岭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441481', '广东省兴宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441500', '广东省汕尾市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441501', '广东省汕尾市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441502', '广东省汕尾市城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441521', '广东省海丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441523', '广东省陆河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441581', '广东省陆丰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441600', '广东省河源市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441601', '广东省河源市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441602', '广东省河源市源城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441621', '广东省紫金县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441622', '广东省龙川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441623', '广东省连平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441624', '广东省和平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441625', '广东省东源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441700', '广东省阳江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441701', '广东省阳江市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441702', '广东省阳江市江城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441721', '广东省阳西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441723', '广东省阳东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441781', '广东省阳春市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441800', '广东省清远市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441801', '广东省清远市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441802', '广东省清远市清城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441821', '广东省佛冈县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441823', '广东省阳山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441825', '广东省连山壮族瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441826', '广东省连南瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441827', '广东省清新县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441881', '广东省英德市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441882', '广东省连州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('441900', '广东省东莞市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('442000', '广东省中山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445100', '广东省潮州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445101', '广东省潮州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445102', '广东省潮州市湘桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445121', '广东省潮安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445122', '广东省饶平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445200', '广东省揭阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445201', '广东省揭阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445202', '广东省揭阳市榕城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445221', '广东省揭东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445222', '广东省揭西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445224', '广东省惠来县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445281', '广东省普宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445300', '广东省云浮市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445301', '广东省云浮市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445302', '广东省云浮市云城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445321', '广东省新兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445322', '广东省郁南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445323', '广东省云安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('445381', '广东省罗定市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450000', '广西壮族自治区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450100', '广西南宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450101', '广西南宁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450102', '广西南宁市兴宁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450103', '广西南宁市新城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450104', '广西南宁市城北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450105', '广西南宁市江南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450106', '广西南宁市永新区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450121', '广西邕宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450122', '广西武鸣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450123', '广西隆安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450124', '广西马山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450125', '广西上林县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450126', '广西宾阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450127', '广西横县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450200', '广西柳州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450201', '广西柳州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450202', '广西柳州市城中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450203', '广西柳州市鱼峰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450204', '广西柳州市柳南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450205', '广西柳州市柳北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450221', '广西柳江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450222', '广西柳城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450223', '广西鹿寨县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450224', '广西融安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450225', '广西融水苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450226', '广西三江侗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450300', '广西桂林市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450301', '广西桂林市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450302', '广西桂林市秀峰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450303', '广西桂林市叠彩区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450304', '广西桂林市象山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450305', '广西桂林市七星区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450311', '广西桂林市雁山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450321', '广西阳朔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450322', '广西临桂县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450323', '广西灵川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450324', '广西全州县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450325', '广西兴安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450326', '广西永福县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450327', '广西灌阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450328', '广西龙胜各族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450329', '广西资源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450330', '广西平乐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450331', '广西荔蒲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450332', '广西恭城瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450400', '广西梧州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450401', '广西梧州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450403', '广西梧州市万秀区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450404', '广西梧州市蝶山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450405', '广西梧州市长洲区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450421', '广西苍梧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450422', '广西藤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450423', '广西蒙山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450481', '广西岑溪市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450500', '广西北海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450501', '广西北海市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450502', '广西北海市海城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450503', '广西北海市银海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450512', '广西北海市铁山港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450521', '广西合浦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450600', '广西防城港市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450601', '广西防城港市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450602', '广西防城港市港口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450603', '广西防城港市防城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450621', '广西上思县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450681', '广西东兴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450700', '广西钦州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450701', '广西钦州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450702', '广西钦州市钦南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450703', '广西钦州市钦北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450721', '广西灵山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450722', '广西浦北县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450800', '广西贵港市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450801', '广西贵港市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450802', '广西贵港市港北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450803', '广西贵港市港南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450804', '广西贵港市覃塘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450821', '广西平南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450881', '广西桂平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450900', '广西玉林市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450901', '广西玉林市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450902', '广西玉林市玉州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450921', '广西容县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450922', '广西陆川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450923', '广西博白县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450924', '广西兴业县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('450981', '广西北流市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451000', '广西百色市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451001', '广西百色市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451002', '广西百色市右江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451021', '广西田阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451022', '广西田东县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451023', '广西平果县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451024', '广西德保县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451025', '广西靖西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451026', '广西那坡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451027', '广西凌云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451028', '广西乐业县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451029', '广西田林县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451030', '广西西林县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451031', '广西隆林各族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451100', '广西贺州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451101', '广西贺州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451102', '广西贺州市八步区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451121', '广西昭平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451122', '广西钟山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542521', '西藏普兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511322', '四川省营山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542500', '西藏阿里地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410505', '河南省安阳市殷都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410506', '河南省安阳市龙安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410522', '河南省安阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410523', '河南省汤阴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410526', '河南省滑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410527', '河南省内黄县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410581', '河南省林州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410600', '河南省鹤壁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410601', '河南省鹤壁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410602', '河南省鹤壁市鹤山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410603', '河南省鹤壁市山城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410611', '河南省鹤壁市淇滨区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410621', '河南省浚县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410622', '河南省淇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410700', '河南省新乡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410701', '河南省新乡市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410702', '河南省新乡市红旗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410703', '河南省新乡市卫滨区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410704', '河南省新乡市凤泉区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410711', '河南省新乡市牧野区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410721', '河南省新乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410724', '河南省获嘉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410725', '河南省原阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410726', '河南省延津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410727', '河南省封丘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410728', '河南省长垣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410781', '河南省卫辉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410782', '河南省辉县市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410800', '河南省焦作市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410801', '河南省焦作市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410802', '河南省焦作市解放区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410803', '河南省焦作市中站区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410804', '河南省焦作市马村区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410811', '河南省焦作市山阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410821', '河南省修武县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410822', '河南省博爱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410823', '河南省武陟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410825', '河南省温县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410881', '河南省济源市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410882', '河南省沁阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410883', '河南省孟州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410900', '河南省濮阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410901', '河南省濮阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410902', '河南省濮阳市华龙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410922', '河南省清丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410923', '河南省南乐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410926', '河南省范县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410927', '河南省台前县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410928', '河南省濮阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411000', '河南省许昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411001', '河南省许昌市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411002', '河南省许昌市魏都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411023', '河南省许昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411024', '河南省鄢陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411025', '河南省襄城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411081', '河南省禹州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411082', '河南省长葛市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411100', '河南省漯河市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411101', '河南省漯河市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411102', '河南省漯河市源汇区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411121', '河南省舞阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411122', '河南省临颍县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411123', '河南省郾城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411200', '河南省三门峡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411201', '河南省三门峡市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411202', '河南省三门峡市湖滨区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411221', '河南省渑池县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411222', '河南省陕县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411224', '河南省卢氏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411281', '河南省义马市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411282', '河南省灵宝市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411300', '河南省南阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411301', '河南省南阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411302', '河南省南阳市宛城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411303', '河南省南阳市卧龙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('411321', '河南省南召县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370400', '山东省枣庄市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370401', '山东省枣庄市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370402', '山东省枣庄市市中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370403', '山东省枣庄市薛城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370404', '山东省枣庄市峄城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370405', '山东省枣庄市台儿庄区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370406', '山东省枣庄市山亭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370481', '山东省滕州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370500', '山东省东营市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370501', '山东省东营市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370502', '山东省东营市东营区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370503', '山东省东营市河口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370521', '山东省垦利县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370522', '山东省利津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370523', '山东省广饶县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370600', '山东省烟台市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370601', '山东省烟台市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370602', '山东省烟台市芝罘区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370611', '山东省烟台市福山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370612', '山东省烟台市牟平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370613', '山东省烟台市莱山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370634', '山东省长岛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370681', '山东省龙口市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370682', '山东省莱阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370683', '山东省莱州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370684', '山东省蓬莱市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370685', '山东省招远市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370686', '山东省栖霞市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370687', '山东省海阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370700', '山东省潍坊市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370701', '山东省潍坊市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370702', '山东省潍坊市潍城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370703', '山东省潍坊市寒亭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370704', '山东省潍坊市坊子区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370705', '山东省潍坊市奎文区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370724', '山东省临朐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370725', '山东省昌乐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370781', '山东省青州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370782', '山东省诸城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370783', '山东省寿光市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370784', '山东省安丘市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370785', '山东省高密市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370786', '山东省昌邑市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370800', '山东省济宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370801', '山东省济宁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370802', '山东省济宁市市中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370811', '山东省济宁市任城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370826', '山东省微山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370827', '山东省鱼台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370828', '山东省金乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370829', '山东省嘉祥县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370830', '山东省汶上县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370831', '山东省泗水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370832', '山东省梁山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370881', '山东省曲阜市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370882', '山东省兖州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370883', '山东省邹城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370900', '山东省泰安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370901', '山东省泰安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370902', '山东省泰安市泰山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370903', '山东省泰安市岱岳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370921', '山东省宁阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370923', '山东省东平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370982', '山东省新泰市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370983', '山东省肥城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371000', '山东省威海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371001', '山东省威海市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371002', '山东省威海市环翠区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371081', '山东省文登市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371082', '山东省荣成市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371083', '山东省乳山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371100', '山东省日照市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371101', '山东省日照市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371102', '山东省日照市东港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371121', '山东省五莲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371122', '山东省莒县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371200', '山东省莱芜市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371201', '山东省莱芜市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371202', '山东省莱芜市莱城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371203', '山东省莱芜市钢城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371300', '山东省临沂市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371301', '山东省临沂市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371302', '山东省临沂市兰山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371311', '山东省临沂市罗庄区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371312', '山东省临沂市河东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371321', '山东省沂南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371322', '山东省郯城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371323', '山东省沂水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371324', '山东省苍山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371325', '山东省费县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371326', '山东省平邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371327', '山东省莒南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371328', '山东省蒙阴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371329', '山东省临沭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371400', '山东省德州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371401', '山东省德州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371402', '山东省德州市德城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371421', '山东省陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371422', '山东省宁津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371423', '山东省庆云县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371424', '山东省临邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371425', '山东省齐河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371426', '山东省平原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371427', '山东省夏津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371428', '山东省武城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371481', '山东省乐陵市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371482', '山东省禹城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371500', '山东省聊城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371501', '山东省聊城市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371502', '山东省聊城市东昌府区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371521', '山东省阳谷县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371522', '山东省莘县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371523', '山东省茌平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371524', '山东省东阿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371525', '山东省冠县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371526', '山东省高唐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371581', '山东省临清市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371600', '山东省滨州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371601', '山东省滨州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371602', '山东省滨州市滨城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371621', '山东省惠民县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371622', '山东省阳信县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371623', '山东省无棣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371624', '山东省沾化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371625', '山东省博兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371626', '山东省邹平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371700', '山东省荷泽市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371701', '山东省荷泽市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371702', '山东省荷泽市牡丹区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371721', '山东省曹县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371722', '山东省单县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371723', '山东省成武县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371724', '山东省巨野县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371725', '山东省郓城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371726', '山东省鄄城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371727', '山东省定陶县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('371728', '山东省东明县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410000', '河南省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410100', '河南省郑州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410101', '河南省郑州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410102', '河南省郑州市中原区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410103', '河南省郑州市二七区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410104', '河南省郑州市管城回族区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410105', '河南省郑州市金水区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410106', '河南省郑州市上街区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410108', '河南省郑州市邙山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410122', '河南省中牟县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410181', '河南省巩义市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410182', '河南省荥阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410183', '河南省新密市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410184', '河南省新郑市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410185', '河南省登封市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410200', '河南省开封市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410201', '河南省开封市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410202', '河南省开封市龙亭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410203', '河南省开封市顺河回族区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410204', '河南省开封市鼓楼区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410205', '河南省开封市南关区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410211', '河南省开封市郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410221', '河南省杞县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410222', '河南省通许县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410223', '河南省尉氏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410224', '河南省开封县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410225', '河南省兰考县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410300', '河南省洛阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410301', '河南省洛阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410302', '河南省洛阳市老城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410303', '河南省洛阳市西工区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410304', '河南省洛阳市廛河回族区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410305', '河南省洛阳市涧西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410306', '河南省洛阳市吉利区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410307', '河南省洛阳市洛龙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410322', '河南省孟津县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410323', '河南省新安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410324', '河南省栾川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410325', '河南省嵩县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410326', '河南省汝阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410327', '河南省宜阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410328', '河南省洛宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410329', '河南省伊川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410381', '河南省偃师市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410400', '河南省平顶山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410401', '河南省平顶山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410402', '河南省平顶山市新华区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410403', '河南省平顶山市卫东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410404', '河南省平顶山市石龙区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410411', '河南省平顶山市湛河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410421', '河南省宝丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410422', '河南省叶县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410423', '河南省鲁山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('410425', '河南省郏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440606', '广东省佛山市顺德区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440607', '广东省佛山市三水区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440608', '广东省佛山市高明区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440700', '广东省江门市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440701', '广东省江门市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440703', '广东省江门市蓬江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440704', '广东省江门市江海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440705', '广东省江门市新会区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440781', '广东省台山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440783', '广东省开平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440784', '广东省鹤山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440785', '广东省恩平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440800', '广东省湛江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440801', '广东省湛江市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440802', '广东省湛江市赤坎区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440803', '广东省湛江市霞山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440804', '广东省湛江市坡头区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440811', '广东省湛江市麻章区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440823', '广东省遂溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440825', '广东省徐闻县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440881', '广东省廉江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440882', '广东省雷州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440883', '广东省吴川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440900', '广东省茂名市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440901', '广东省茂名市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440902', '广东省茂名市茂南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440903', '广东省茂名市茂港区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440923', '广东省电白县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440981', '广东省高州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370322', '山东省高青县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370323', '山东省沂源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610631', '陕西省黄龙县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610632', '陕西省黄陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610700', '陕西省汉中市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610701', '陕西省汉中市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610702', '陕西省汉中市汉台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610721', '陕西省南郑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610722', '陕西省城固县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610723', '陕西省洋县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610724', '陕西省西乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610725', '陕西省勉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610726', '陕西省宁强县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610727', '陕西省略阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610728', '陕西省镇巴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610729', '陕西省留坝县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610730', '陕西省佛坪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610800', '陕西省榆林市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610801', '陕西省榆林市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610802', '陕西省榆林市榆阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610821', '陕西省神木县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610822', '陕西省府谷县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610823', '陕西省横山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610824', '陕西省靖边县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610825', '陕西省定边县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610826', '陕西省绥德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610827', '陕西省米脂县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610828', '陕西省佳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610829', '陕西省吴堡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610830', '陕西省清涧县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610831', '陕西省子洲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610900', '陕西省安康市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610901', '陕西省安康市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610902', '陕西省安康市汉滨区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610921', '陕西省汉阴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610922', '陕西省石泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610923', '陕西省宁陕县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610924', '陕西省紫阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610925', '陕西省岚皋县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610926', '陕西省平利县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610927', '陕西省镇坪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610928', '陕西省旬阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610929', '陕西省白河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611000', '陕西省商洛市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611001', '陕西省商洛市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611002', '陕西省商洛市商州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611021', '陕西省洛南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611022', '陕西省丹凤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611023', '陕西省商南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611024', '陕西省山阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611025', '陕西省镇安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('611026', '陕西省柞水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620000', '甘肃省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620100', '甘肃省兰州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620101', '甘肃省兰州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620102', '甘肃省兰州市城关区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620103', '甘肃省兰州市七里河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620104', '甘肃省兰州市西固区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620105', '甘肃省兰州市安宁区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620111', '甘肃省兰州市红古区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620121', '甘肃省永登县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620122', '甘肃省皋兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620123', '甘肃省榆中县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620200', '甘肃省嘉峪关市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620201', '甘肃省嘉峪关市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620300', '甘肃省金昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620301', '甘肃省金昌市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620302', '甘肃省金昌市金川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620321', '甘肃省永昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620400', '甘肃省白银市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620401', '甘肃省白银市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620402', '甘肃省白银市白银区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620403', '甘肃省白银市平川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620421', '甘肃省靖远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620422', '甘肃省会宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620423', '甘肃省景泰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620500', '甘肃省天水市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620501', '甘肃省天水市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620502', '甘肃省天水市秦城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620503', '甘肃省天水市北道区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620521', '甘肃省清水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620522', '甘肃省秦安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620523', '甘肃省甘谷县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620524', '甘肃省武山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620525', '甘肃省张家川回族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620600', '甘肃省武威市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620601', '甘肃省武威市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620602', '甘肃省武威市凉州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620621', '甘肃省民勤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620622', '甘肃省古浪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620623', '甘肃省天祝藏族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620700', '甘肃省张掖市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620701', '甘肃省张掖市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620702', '甘肃省张掖市甘州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620721', '甘肃省肃南裕固族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620722', '甘肃省民乐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620723', '甘肃省临泽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620724', '甘肃省高台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620725', '甘肃省山丹县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620800', '甘肃省平凉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620801', '甘肃省平凉市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620802', '甘肃省平凉市崆峒区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620821', '甘肃省泾川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620822', '甘肃省灵台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620823', '甘肃省崇信县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620824', '甘肃省华亭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620825', '甘肃省庄浪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620826', '甘肃省静宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620900', '甘肃省酒泉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620901', '甘肃省酒泉市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620902', '甘肃省酒泉市肃州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620921', '甘肃省金塔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620922', '甘肃省安西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620923', '甘肃省肃北蒙古族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620924', '甘肃省阿克塞哈萨克族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620981', '甘肃省玉门市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('620982', '甘肃省敦煌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621000', '甘肃省庆阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621001', '甘肃省庆阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621002', '甘肃省庆阳市西峰区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621021', '甘肃省庆城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621022', '甘肃省环县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621023', '甘肃省华池县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621024', '甘肃省合水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621025', '甘肃省正宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621026', '甘肃省宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621027', '甘肃省镇原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621100', '甘肃省定西市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621101', '甘肃省定西市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621102', '甘肃省定西市安定区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621121', '甘肃省通渭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621122', '甘肃省陇西县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621123', '甘肃省渭源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621124', '甘肃省临洮县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621125', '甘肃省漳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621126', '甘肃省岷县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621200', '甘肃省陇南市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621201', '甘肃省陇南市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621202', '甘肃省陇南市武都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621221', '甘肃省成县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621222', '甘肃省文县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621223', '甘肃省宕昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621224', '甘肃省康县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621225', '甘肃省西和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621226', '甘肃省礼县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621227', '甘肃省徽县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('621228', '甘肃省两当县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622900', '甘肃省临夏回族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622901', '甘肃省临夏市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622921', '甘肃省临夏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622922', '甘肃省康乐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622923', '甘肃省永靖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622924', '甘肃省广河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622925', '甘肃省和政县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622926', '甘肃省东乡族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('622927', '甘肃省积石山保安族东乡族撒拉族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623000', '甘肃省甘南藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623001', '甘肃省合作市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623021', '甘肃省临潭县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623022', '甘肃省卓尼县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623023', '甘肃省舟曲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623024', '甘肃省迭部县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623025', '甘肃省玛曲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623026', '甘肃省碌曲县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('623027', '甘肃省夏河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630000', '青海省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630100', '青海省西宁市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630101', '青海省西宁市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630102', '青海省西宁市城东区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630103', '青海省西宁市城中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630104', '青海省西宁市城西区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630105', '青海省西宁市城北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630121', '青海省大通回族土族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630122', '青海省湟中县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('630123', '青海省湟源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632100', '青海省海东地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632121', '青海省平安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632122', '青海省民和回族土族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632123', '青海省乐都县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632126', '青海省互助土族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632127', '青海省化隆回族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632128', '青海省循化撒拉族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632200', '青海省海北藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632221', '青海省门源回族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632222', '青海省祁连县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632223', '青海省海晏县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632224', '青海省刚察县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632300', '青海省黄南藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632321', '青海省同仁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632322', '青海省尖扎县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632323', '青海省泽库县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632324', '青海省河南蒙古族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632500', '青海省海南藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632521', '青海省共和县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632522', '青海省同德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632523', '青海省贵德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632524', '青海省兴海县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632525', '青海省贵南县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632600', '青海省果洛藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632621', '青海省玛沁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632622', '青海省班玛县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632623', '青海省甘德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632624', '青海省达日县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632625', '青海省久治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632626', '青海省玛多县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632700', '青海省玉树藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632721', '青海省玉树县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632722', '青海省杂多县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632723', '青海省称多县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632724', '青海省治多县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632725', '青海省囊谦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632726', '青海省曲麻莱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632800', '青海省海西蒙古族藏族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632801', '青海省格尔木市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340521', '安徽省当涂县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340600', '安徽省淮北市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340601', '安徽省淮北市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340602', '安徽省淮北市杜集区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340603', '安徽省淮北市相山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340604', '安徽省淮北市烈山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340621', '安徽省濉溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340700', '安徽省铜陵市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340701', '安徽省铜陵市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340702', '安徽省铜陵市铜官山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340703', '安徽省铜陵市狮子山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340711', '安徽省铜陵市郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340721', '安徽省铜陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340800', '安徽省安庆市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340801', '安徽省安庆市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340802', '安徽省安庆市迎江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340803', '安徽省安庆市大观区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340811', '安徽省安庆市郊区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340822', '安徽省怀宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340823', '安徽省枞阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('340824', '安徽省潜山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542522', '西藏札达县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542523', '西藏噶尔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542524', '西藏日土县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542525', '西藏革吉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542526', '西藏改则县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542527', '西藏措勤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542600', '西藏林芝地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542621', '西藏林芝县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542622', '西藏工布江达县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542623', '西藏米林县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542624', '西藏墨脱县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542625', '西藏波密县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542626', '西藏察隅县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('542627', '西藏朗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610000', '陕西省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610100', '陕西省西安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610101', '陕西省西安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610102', '陕西省西安市新城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610103', '陕西省西安市碑林区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610104', '陕西省西安市莲湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610111', '陕西省西安市灞桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610112', '陕西省西安市未央区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610113', '陕西省西安市雁塔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610114', '陕西省西安市阎良区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610115', '陕西省西安市临潼区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610116', '陕西省西安市长安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610122', '陕西省蓝田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610124', '陕西省周至县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610125', '陕西省户县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610126', '陕西省高陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610200', '陕西省铜川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610201', '陕西省铜川市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610202', '陕西省铜川市王益区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610203', '陕西省铜川市印台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610204', '陕西省铜川市耀州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610222', '陕西省宜君县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610300', '陕西省宝鸡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610301', '陕西省宝鸡市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610302', '陕西省宝鸡市渭滨区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610303', '陕西省宝鸡市金台区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610304', '陕西省宝鸡市陈仓区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610322', '陕西省凤翔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610323', '陕西省岐山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610324', '陕西省扶风县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610326', '陕西省眉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610327', '陕西省陇县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610328', '陕西省千阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610329', '陕西省麟游县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610330', '陕西省凤县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610331', '陕西省太白县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610400', '陕西省咸阳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610401', '陕西省咸阳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610402', '陕西省咸阳市秦都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610403', '陕西省咸阳市杨凌区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610404', '陕西省咸阳市渭城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610422', '陕西省三原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610423', '陕西省泾阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610424', '陕西省乾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610425', '陕西省礼泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610426', '陕西省永寿县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610427', '陕西省彬县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610428', '陕西省长武县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610429', '陕西省旬邑县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610430', '陕西省淳化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610431', '陕西省武功县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610481', '陕西省兴平市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610500', '陕西省渭南市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610501', '陕西省渭南市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610502', '陕西省渭南市临渭区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610521', '陕西省华县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610522', '陕西省潼关县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610523', '陕西省大荔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610524', '陕西省合阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610525', '陕西省澄城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610526', '陕西省蒲城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610527', '陕西省白水县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610528', '陕西省富平县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610581', '陕西省韩城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610582', '陕西省华阴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610600', '陕西省延安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610601', '陕西省延安市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610602', '陕西省延安市宝塔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610621', '陕西省延长县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610622', '陕西省延川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610623', '陕西省子长县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610624', '陕西省安塞县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610625', '陕西省志丹县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610626', '陕西省吴旗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610627', '陕西省甘泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610628', '陕西省富县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610629', '陕西省洛川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('610630', '陕西省宜川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632802', '青海省德令哈市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632821', '青海省乌兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632822', '青海省都兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('632823', '青海省天峻县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640000', '宁夏回族自治区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640100', '宁夏银川市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640101', '宁夏银川市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640104', '宁夏银川市兴庆区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640105', '宁夏银川市西夏区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640106', '宁夏银川市金凤区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640121', '宁夏永宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640122', '宁夏贺兰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640181', '宁夏灵武市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640200', '宁夏石嘴山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640201', '宁夏石嘴山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640202', '宁夏石嘴山市大武口区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640205', '宁夏石嘴山市惠农区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640221', '宁夏平罗县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640300', '宁夏吴忠市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640301', '宁夏吴忠市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640302', '宁夏吴忠市利通区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640323', '宁夏盐池县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640324', '宁夏同心县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640381', '宁夏青铜峡市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640400', '宁夏固原市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640401', '宁夏固原市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640402', '宁夏固原市原州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640422', '宁夏西吉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640423', '宁夏隆德县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640424', '宁夏泾源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640425', '宁夏彭阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640500', '宁夏中卫市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640501', '宁夏中卫市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640502', '宁夏中卫市沙坡头区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640521', '宁夏中宁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('640522', '宁夏海原县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650000', '新疆维吾尔自治区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650100', '新疆乌鲁木齐市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650101', '新疆乌鲁木齐市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650102', '新疆乌鲁木齐市天山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650103', '新疆乌鲁木齐市沙依巴克区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650104', '新疆乌鲁木齐市新市区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650105', '新疆乌鲁木齐市水磨沟区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650106', '新疆乌鲁木齐市头屯河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650107', '新疆乌鲁木齐市达坂城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650108', '新疆乌鲁木齐市东山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650121', '新疆乌鲁木齐县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650200', '新疆克拉玛依市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650201', '新疆克拉玛依市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650202', '新疆克拉玛依市独山子区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650203', '新疆克拉玛依市克拉玛依区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650204', '新疆克拉玛依市白碱滩区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('650205', '新疆克拉玛依市乌尔禾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652100', '新疆克拉玛依市吐鲁番地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652101', '新疆吐鲁番市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652122', '新疆鄯善县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652123', '新疆托克逊县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652200', '新疆哈密地区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652201', '新疆哈密市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652222', '新疆巴里坤哈萨克自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652223', '新疆伊吾县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652300', '新疆昌吉回族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652301', '新疆昌吉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652302', '新疆阜康市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652303', '新疆米泉市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652323', '新疆呼图壁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652324', '新疆玛纳斯县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652325', '新疆奇台县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652327', '新疆吉木萨尔县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652328', '新疆木垒哈萨克自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652700', '新疆博尔塔拉蒙古自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652701', '新疆博乐市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652722', '新疆精河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652723', '新疆温泉县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652800', '新疆巴音郭楞蒙古自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('652801', '新疆库尔勒市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431101', '湖南省永州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431102', '湖南省永州市芝山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431103', '湖南省永州市冷水滩区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431121', '湖南省祁阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431122', '湖南省东安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431123', '湖南省双牌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431124', '湖南省道县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431125', '湖南省江永县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431126', '湖南省宁远县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431127', '湖南省蓝山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431128', '湖南省新田县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431129', '湖南省江华瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431200', '湖南省怀化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431201', '湖南省怀化市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431202', '湖南省怀化市鹤城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431221', '湖南省中方县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431222', '湖南省沅陵县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431223', '湖南省辰溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431224', '湖南省溆浦县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431225', '湖南省会同县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431226', '湖南省麻阳苗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431227', '湖南省新晃侗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431228', '湖南省芷江侗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431229', '湖南省靖州苗族侗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431230', '湖南省通道侗族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431281', '湖南省洪江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431300', '湖南省娄底市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431301', '湖南省娄底市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431302', '湖南省娄底市娄星区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431321', '湖南省双峰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431322', '湖南省新化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431381', '湖南省冷水江市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('431382', '湖南省涟源市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433100', '湖南省湘西土家族苗族自治州', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433101', '湖南省吉首市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433122', '湖南省泸溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433123', '湖南省凤凰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433124', '湖南省花垣县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433125', '湖南省保靖县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433126', '湖南省古丈县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433127', '湖南省永顺县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('433130', '湖南省龙山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440000', '广东省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440100', '广东省广州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440101', '广东省广州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440102', '广东省广州市东山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440103', '广东省广州市荔湾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440104', '广东省广州市越秀区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440105', '广东省广州市海珠区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440106', '广东省广州市天河区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440107', '广东省广州市芳村区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440111', '广东省广州市白云区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440112', '广东省广州市黄埔区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440113', '广东省广州市番禺区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440114', '广东省广州市花都区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440183', '广东省增城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440184', '广东省从化市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440200', '广东省韶关市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440201', '广东省韶关市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440202', '广东省韶关市北江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440203', '广东省韶关市武江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440204', '广东省韶关市浈江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440221', '广东省曲江县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440222', '广东省始兴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440224', '广东省仁化县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440229', '广东省翁源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440232', '广东省乳源瑶族自治县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440233', '广东省新丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440281', '广东省乐昌市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440282', '广东省南雄市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440300', '广东省深圳市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440301', '广东省深圳市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440303', '广东省深圳市罗湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440304', '广东省深圳市福田区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440305', '广东省深圳市南山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440306', '广东省深圳市宝安区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440307', '广东省深圳市龙岗区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440308', '广东省深圳市盐田区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440400', '广东省珠海市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440401', '广东省珠海市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440402', '广东省珠海市香洲区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440403', '广东省珠海市斗门区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440404', '广东省珠海市金湾区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440500', '广东省汕头市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440501', '广东省汕头市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440507', '广东省汕头市龙湖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440511', '广东省汕头市金平区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440512', '广东省汕头市濠江区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440513', '广东省汕头市潮阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440514', '广东省汕头市潮南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440515', '广东省汕头市澄海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440523', '广东省南澳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440600', '广东省佛山市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440601', '广东省佛山市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440604', '广东省佛山市禅城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('440605', '广东省佛山市南海区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('511323', '四川省蓬安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('451200', '广西河池市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360902', '江西省宜春市袁州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360921', '江西省奉新县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360922', '江西省万载县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360923', '江西省上高县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360924', '江西省宜丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360925', '江西省靖安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360926', '江西省铜鼓县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360981', '江西省丰城市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360982', '江西省樟树市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('360983', '江西省高安市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361000', '江西省抚州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361001', '江西省抚州市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361002', '江西省抚州市临川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361021', '江西省南城县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361022', '江西省黎川县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361023', '江西省南丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361024', '江西省崇仁县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361025', '江西省乐安县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361026', '江西省宜黄县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361027', '江西省金溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361028', '江西省资溪县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361029', '江西省东乡县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361030', '江西省广昌县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361100', '江西省上饶市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361101', '江西省上饶市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361102', '江西省上饶市信州区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361121', '江西省上饶县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361122', '江西省广丰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361123', '江西省玉山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361124', '江西省铅山县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361125', '江西省横峰县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361126', '江西省弋阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361127', '江西省余干县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361128', '江西省鄱阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361129', '江西省万年县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361130', '江西省婺源县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('361181', '江西省德兴市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370000', '山东省', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370100', '山东省济南市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370101', '山东省济南市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370102', '山东省济南市历下区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370103', '山东省济南市市中区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370104', '山东省济南市槐荫区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370105', '山东省济南市天桥区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370112', '山东省济南市历城区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370113', '山东省济南市长清区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370124', '山东省平阴县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370125', '山东省济阳县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370126', '山东省商河县', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370181', '山东省章丘市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370200', '山东省青岛市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370201', '山东省青岛市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370202', '山东省青岛市市南区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370203', '山东省青岛市市北区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370205', '山东省青岛市四方区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370211', '山东省青岛市黄岛区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370212', '山东省青岛市崂山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370213', '山东省青岛市李沧区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370214', '山东省青岛市城阳区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370281', '山东省胶州市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370282', '山东省即墨市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370283', '山东省平度市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370284', '山东省胶南市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370285', '山东省莱西市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370300', '山东省淄博市', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370301', '山东省淄博市市辖区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370302', '山东省淄博市淄川区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370303', '山东省淄博市张店区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370304', '山东省淄博市博山区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370305', '山东省淄博市临淄区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370306', '山东省淄博市周村区', null);
insert into t_md_area_code (CODE, NAME, SORT_NO)
values ('370321', '山东省桓台县', null);

insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('01', '国内安全保卫(局、处、科)', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('02', '经济犯罪侦察', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('03', '治安管理', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('04', '边防管理', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('05', '形势侦察', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('06', '出入境管理', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('07', '消防', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('08', '警卫', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('09', '中办警卫', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('11', '公共信息网络安全监察', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('12', '行动技术', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('13', '监所管理', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('17', '交通管理', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('18', '法制', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('19', '外事', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('20', '装备财务', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('21', '禁毒', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('22', '科技', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('23', '信息通信', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('26', '反邪教', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('27', '反恐怖', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('31', '办公厅', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('41', '指挥中心', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('42', '信访办', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('43', '调研室', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('32', '纪委', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('33', '监察', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('34', '督促', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('35', '政治部', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('36', '人事训练', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('37', '宣传', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('38', '机关党委', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('39', '离退休干部', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('40', '机关服务中心', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('98', '金盾办', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('99', '科技委', '1');
insert into t_md_orgbiz_code (CODE, NAME, IS_ACTIVE)
values ('00', '部、厅、局、分局', '1');

insert into t_md_orgtype (CODE, NAME, SORT_NO)
values ('1', '行政单位', 1);
insert into t_md_orgtype (CODE, NAME, SORT_NO)
values ('2', '业务单位', 2);

insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100000', '1', '汉族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100001', '2', '蒙古族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100002', '3', '回族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100003', '4', '藏族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100004', '5', '维吾尔族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100005', '6', '苗族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100006', '7', '彝族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100007', '8', '壮族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100008', '9', '布依族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100009', '10', '朝鲜族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100010', '11', '满族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100011', '12', '侗族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100012', '13', '瑶族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100013', '14', '白族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100014', '15', '土家族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100015', '16', '哈尼族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100016', '17', '哈萨克族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100017', '18', '傣族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100018', '19', '黎族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100019', '20', '傈僳族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100020', '21', '佤族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100021', '22', '畲族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100022', '23', '高山族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100023', '24', '拉祜族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100024', '25', '水族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100025', '26', '东乡族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100026', '27', '纳西族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100027', '28', '景颇族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100028', '29', '柯尔克孜族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100029', '30', '土族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100030', '31', '达斡尔族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100031', '32', '仫佬族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100032', '33', '羌族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100033', '34', '布朗族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100034', '35', '撒拉族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100035', '36', '毛难族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100036', '37', '仡佬族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100037', '38', '锡伯族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100038', '39', '阿昌族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100039', '40', '普米族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100040', '41', '塔吉克族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100041', '42', '怒族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100042', '43', '乌孜别克族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100043', '44', '俄罗斯族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100044', '45', '鄂温克族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100045', '46', '崩龙族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100046', '47', '保安族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100047', '48', '裕固族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100048', '49', '京族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100049', '50', '塔塔尔族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100050', '51', '独龙族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100051', '52', '鄂伦春族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100052', '53', '赫哲族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100053', '54', '门巴族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100054', '55', '珞巴族');
insert into DM_NATION_CODE (ID, CODE, NAME)
values ('100055', '56', '基诺族');

insert into t_md_police_type (CODE, VALUE)
values ('01', '刑侦');
insert into t_md_police_type (CODE, VALUE)
values ('02', '治安');
insert into t_md_police_type (CODE, VALUE)
values ('03', '经侦');
insert into t_md_police_type (CODE, VALUE)
values ('04', '网监');
insert into t_md_police_type (CODE, VALUE)
values ('05', '禁毒');
insert into t_md_police_type (CODE, VALUE)
values ('06', '反恐');
insert into t_md_police_type (CODE, VALUE)
values ('07', '出入境');
insert into t_md_police_type (CODE, VALUE)
values ('08', '国防');
insert into t_md_police_type (CODE, VALUE)
values ('09', '情报');
insert into t_md_police_type (CODE, VALUE)
values ('10', '国保');
insert into t_md_police_type (CODE, VALUE)
values ('11', '边防');
insert into t_md_police_type (CODE, VALUE)
values ('12', '消防');
insert into t_md_police_type (CODE, VALUE)
values ('13', '边检');
insert into t_md_police_type (CODE, VALUE)
values ('14', '巡警');
insert into t_md_police_type (CODE, VALUE)
values ('15', '技侦');
insert into t_md_police_type (CODE, VALUE)
values ('16', '交管');
insert into t_md_police_type (CODE, VALUE)
values ('17', '纪委');
insert into t_md_police_type (CODE, VALUE)
values ('18', '视频监控');
insert into t_md_police_type (CODE, VALUE)
values ('19', '科信');
insert into t_md_police_type (CODE, VALUE)
values ('20', '其他');

insert into dm_sys_code (CODE, VALUE, CODE_ID)
values ('0', '部级', 'rolelevel');
insert into dm_sys_code (CODE, VALUE, CODE_ID)
values ('1', '省级', 'rolelevel');
insert into dm_sys_code (CODE, VALUE, CODE_ID)
values ('2', '地市级', 'rolelevel');
insert into dm_sys_code (CODE, VALUE, CODE_ID)
values ('3', '区县级', 'rolelevel');
insert into dm_sys_code (CODE, VALUE, CODE_ID)
values ('4', '派出所', 'rolelevel');
insert into dm_sys_code (CODE, VALUE, CODE_ID)
values ('9', '通用', 'rolelevel');

insert into t_md_org_level (CODE, NAME, SORT_NO)
values ('0', '部级', 1);
insert into t_md_org_level (CODE, NAME, SORT_NO)
values ('1', '省级', 2);
insert into t_md_org_level (CODE, NAME, SORT_NO)
values ('2', '地市级', 3);
insert into t_md_org_level (CODE, NAME, SORT_NO)
values ('3', '区县级', 4);
insert into t_md_org_level (CODE, NAME, SORT_NO)
values ('4', '派出所', 5);

 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0051', '其他（刑事侦查）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0052', '出入境管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0053', '网络安全保卫', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0054', '技术侦察', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0055', '监所管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0056', '监所', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0057', '看守所', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0058', '拘留所', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0059', '收容教育所', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0060', '强制戒毒所', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0061', '安康医院', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0062', '其他（监所）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0063', '交通管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0064', '道路执勤执法', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0065', '交通事故处理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0066', '车辆和驾驶人管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0067', '其他（交通管理）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0068', '民用航空', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0069', '交通运输', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0070', '法制', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0071', '国际合作（外事）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0072', '警务保障', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0073', '装备财务', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0074', '后勤服务', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0075', '其他（警务保障）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0076', '禁毒', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0077', '禁毒管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0078', '缉毒队', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0079', '其他（禁毒）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0080', '科技信息化', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0081', '科技管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0082', '信息通信', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0083', '其他（科技信息化）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0084', '反邪教', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0085', '反恐怖', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0086', '情报信息', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0087', '离退休管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0088', '机关党委', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0089', '公安院校', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0090', '科研', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0091', '培训基地', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0092', '公安医院', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0093', '机关附属单位', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0094', '边防', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0095', '消防', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0096', '警卫', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0097', '缉私', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0098', '维稳办', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0099', '国家林业', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0100', '森林', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0001', '实有人口管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0002', '治安重点人管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0003', '行业场所治安管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0004', '枪支管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0005', '爆炸危险物品协同管控', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0006', '重点单位安保管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0007', '保安服务监督管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0008', '治安案事件管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0009', '派出所基础建设管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0010', '公安特巡警队管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0011', '剧毒化学品管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0012', '大型活动管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0013', '水上治安管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0014', '行动队管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0015', '治安管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0016', '经济保卫', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0017', '户政管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0018', '治安行动队', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0019', '公安特警队', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0020', '巡警队', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0021', '水警', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0022', '治安检查站', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0023', '地铁公交安保', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0024', '纪检、监察、督察、审计', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0025', '纪检监察', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0026', '督察', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0027', '审计', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0028', '办公室', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0029', '指挥中心', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0030', '调研', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0031', '机要', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0032', '统计', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0033', '档案', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0034', '信访', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0035', '新闻', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0036', '政工', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0037', '人事训练', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0038', '组织人事', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0039', '教育训练', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0040', '综合', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0041', '宣传', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0042', '国内安全保卫', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0043', '文保保卫', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0044', '其他（国内安全保卫）', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0045', '经济犯罪侦查', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0046', '刑侦', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0047', '刑侦管理', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0048', '刑警队', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0049', '刑事技术', '02');
 insert into dm_police_business (CODE, VALUE, POLICE_TYPE_ID) values ('0050', '警犬技术', '02');


insert into DM_APPLY_CATEGORY (CODE, VALUE)
values ('1', '信息服务');
insert into DM_APPLY_CATEGORY (CODE, VALUE)
values ('2', '应用集成');
insert into DM_APPLY_CATEGORY (CODE, VALUE)
values ('3', '治安管理');

insert into DM_APPLY_STATUS (CODE, VALUE)
values ('0', '启用');
insert into DM_APPLY_STATUS (CODE, VALUE)
values ('1', '停用');

insert into DM_TENANT_OBJECT (CODE, VALUE)
values ('10', '警务人员');
insert into DM_TENANT_OBJECT (CODE, VALUE)
values ('20', '厂商');

insert into dm_auxiliary_type (CODE, VALUE)
values ('10', '合同工');
insert into dm_auxiliary_type (CODE, VALUE)
values ('20', '聘用');
insert into dm_auxiliary_type (CODE, VALUE)
values ('30', '事业编');
insert into dm_auxiliary_type (CODE, VALUE)
values ('40', '返聘');
insert into dm_auxiliary_type (CODE, VALUE)
values ('90', '其他');

insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('100', '第一层级单位', '', '');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('110', '省公安厅', '1', '100');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('120', '自治区公安厅', '', '100');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('130', '直辖市公安局', '', '100');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('140', '新疆生产建设兵团公安局', '', '100');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('200', '第二层级单位', '', '');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('210', '省辖市公安局', '', '200');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('220', '地区公安局（处）', '', '200');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('230', '省直辖行政单位公安局', '', '200');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('240', '省直管县公安局', '', '200');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('290', '其他第二层级单位', '', '200');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('300', '第三层级单位', '', '');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('310', '设区市的区公安局（分局）', '', '300');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('320', '地区和省辖市下辖的县、市公安局（分局）', '', '300');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('390', '其他第三层级单位', '', '300');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('400', '第四层级单位（公安派出所）', '', '');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('410', '城区派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('411', '城区户籍派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('412', '城区治安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('420', '建制镇派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('421', '建制镇户籍派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('422', '建制镇治安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('430', '建制乡派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('431', '建制乡户籍派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('432', '建制乡治安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('450', '水上派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('451', ' 水上户籍派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('452', '水上治安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('460', '公安边防派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('461', '具有户籍管理职能的边防派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('469', '其他公安边防派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('470', '公交派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('480', '行业系统派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('481', '铁路公安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('482', '交通公安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('483', '民航公安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('484', '林业公安派出所', '', '400');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('500', '第五层级单位（警务责任区）', '', '');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('510', '城区警务责任区', '', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('511', '主城区警务责任区', '对应统计部门《城乡分类代码》的111"主城区"。', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('512', '城乡结合区警务责任区', '对应统计部门《城乡分类代码》的112“城乡结合部”。', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('520', '镇区警务责任区', '', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('521', '镇中心区警务责任区', '对应统计部门《城乡分类代码》的121“镇中心区”。', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('522', '镇乡结合区警务责任区', '对应统计部门《城乡分类代码》的122“镇乡结合区”。', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('523', '其他镇区警务责任区', '对应统计部门《城乡分类代码》的123“其他镇区”。', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('530', '乡村警务责任区', '', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('531', '乡中心区警务责任区', '对应统计部门《城乡分类代码》的210“乡中心区”。', '500');
insert into t_md_unit_class (CODE, VALUE, REMARK, PCODE)
values ('532', '村庄警务责任区', '对应统计部门《城乡分类代码》的220“村庄”。', '500');

insert into dm_man_type (CODE, VALUE)
values ('10', '民警');
insert into dm_man_type (CODE, VALUE)
values ('15', '现役');
insert into dm_man_type (CODE, VALUE)
values ('20', '特警');
insert into dm_man_type (CODE, VALUE)
values ('25', '文职');
insert into dm_man_type (CODE, VALUE)
values ('30', '干部');
insert into dm_man_type (CODE, VALUE)
values ('40', '消防员');
insert into dm_man_type (CODE, VALUE)
values ('99999', '其他工勤人员');

insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('01', '正部级单位', 1);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('02', '副部级单位', 2);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('11', '正厅级单位', 3);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('12', '副厅级单位', 4);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('21', '正处级单位', 5);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('22', '副处级单位', 6);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('31', '正科级单位', 7);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('32', '副科级单位', 8);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('41', '正股级单位', 9);
insert into t_md_org_rank (CODE, NAME, SORT_NO)
values ('42', '副股级单位', 10);

DELETE FROM DM_AREA_CODE;
insert into DM_AREA_CODE (CODE, NAME)
values ('130000', '河北省');
insert into DM_AREA_CODE (CODE, NAME)
values ('120000', '天津市');
insert into DM_AREA_CODE (CODE, NAME)
values ('110000', '北京市');
insert into DM_AREA_CODE (CODE, NAME)
values ('140000', '山西省');
insert into DM_AREA_CODE (CODE, NAME)
values ('150000', '内蒙古自治区');
insert into DM_AREA_CODE (CODE, NAME)
values ('210000', '辽宁省');
insert into DM_AREA_CODE (CODE, NAME)
values ('220000', '吉林省');
insert into DM_AREA_CODE (CODE, NAME)
values ('230000', '黑龙江省');
insert into DM_AREA_CODE (CODE, NAME)
values ('310000', '上海市');
insert into DM_AREA_CODE (CODE, NAME)
values ('320000', '江苏省');
insert into DM_AREA_CODE (CODE, NAME)
values ('330000', '浙江省');
insert into DM_AREA_CODE (CODE, NAME)
values ('340000', '安徽省');
insert into DM_AREA_CODE (CODE, NAME)
values ('350000', '福建省');
insert into DM_AREA_CODE (CODE, NAME)
values ('360000', '江西省');
insert into DM_AREA_CODE (CODE, NAME)
values ('370000', '山东省');
insert into DM_AREA_CODE (CODE, NAME)
values ('410000', '河南省');
insert into DM_AREA_CODE (CODE, NAME)
values ('420000', '湖北省');
insert into DM_AREA_CODE (CODE, NAME)
values ('430000', '湖南省');
insert into DM_AREA_CODE (CODE, NAME)
values ('440000', '广东省');
insert into DM_AREA_CODE (CODE, NAME)
values ('450000', '广西壮族自治区');
insert into DM_AREA_CODE (CODE, NAME)
values ('460000', '海南省');
insert into DM_AREA_CODE (CODE, NAME)
values ('500000', '重庆市');
insert into DM_AREA_CODE (CODE, NAME)
values ('510000', '四川省');
insert into DM_AREA_CODE (CODE, NAME)
values ('520000', '贵州省');
insert into DM_AREA_CODE (CODE, NAME)
values ('530000', '云南省');
insert into DM_AREA_CODE (CODE, NAME)
values ('540000', '西藏自治区');
insert into DM_AREA_CODE (CODE, NAME)
values ('610000', '陕西省');
insert into DM_AREA_CODE (CODE, NAME)
values ('620000', '甘肃省');
insert into DM_AREA_CODE (CODE, NAME)
values ('630000', '青海省');
insert into DM_AREA_CODE (CODE, NAME)
values ('640000', '宁夏回族自治区');
insert into DM_AREA_CODE (CODE, NAME)
values ('650000', '新疆维吾尔自治区');

insert into dm_user_status values ('1','在职');
insert into dm_user_status values ('0','离职');

insert into DM_JOB_TYPE (CODE, VALUE)
values ('11', '在职');
insert into DM_JOB_TYPE (CODE, VALUE)
values ('12', '借调');
insert into DM_JOB_TYPE (CODE, VALUE)
values ('13', '挂职');
insert into DM_JOB_TYPE (CODE, VALUE)
values ('15', '退休');
insert into DM_JOB_TYPE (CODE, VALUE)
values ('16', '离职');

